/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 guy keren, choo@actcom.co.il             */
/* License: GNU General Public License                              */

/*
 *$Id: syscall_hijack_private.h,v 1.1 2002/09/19 16:22:25 mulix Exp $
 */

#ifndef _MODULE_HIJACK_SYSCALL_HIJACK_PRIVATE_H_
#define _MODULE_HIJACK_SYSCALL_HIJACK_PRIVATE_H_

/* type of info stored per syscall. */
struct syscall_hijack_data {
	func_ptr orig_syscall;	        /* for syscall restore.                  */
	func_ptr before_hijack_func;    /* hijacking function - before syscall.  */
	func_ptr after_hijack_func;	/* hijacking function - after syscall.   */
	struct semaphore sem;	        /* per-syscall semaphore.                */
	atomic_t invocations;	        /* how many current active invocations?  */
	int defered_release_flag;	/* is there a pending (defered) release? */
	struct list_head pid_list;      /* the list of pids in this syscall currently */ 
};

/* when to invoke a hijack function - 'before' or 'after' syscall. */
typedef enum {
	HFW_BEFORE = 0,
	HFW_AFTER
} hijack_func_when_t;

#endif /* _MODULE_HIJACK_SYSCALL_HIJACK_PRIVATE_H_ */ 
