/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 Muli Ben-Yehuda, mulix@actcom.co.il      */
/* License: GNU General Public License                              */

/*
 * $Id: ctrl_dev.h,v 1.3 2003/01/29 15:47:24 mulix Exp $
 */ 

#ifndef CTRL_DEV_H_
#define CTRL_DEV_H_

#include "sct_rules/membuf.h"
#include "common/sct_compat.h"

/* the control device has a request buffer, for copying the requst from user */ 
/* space, a response buffer, for copying the response back to user */ 
/* space, and a semaphore, to make sure only one client gets access */ 
/* to the device at any given time */ 
typedef struct sct_ctrl_dev_type {
	struct sct_membuf* req; 
	struct sct_membuf* resp; 
	struct semaphore sem;     /* Mutual exclusion */
} sct_ctrl_dev_t;

int init_ctrl_dev_file(sct_ctrl_dev_t** dev); 

void destroy_ctrl_dev_file(sct_ctrl_dev_t* dev); 

#endif /* CTRL_DEV_H_ */ 
