/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 Muli Ben-Yehuda, mulix@actcom.co.il      */
/* License: GNU General Public License                              */

/*
 * $Id: log_dev.h,v 1.3 2002/09/14 07:21:45 mulix Exp $
 */ 

#ifndef LOG_DEV_H_
#define LOG_DEV_H_

#include "common/sct_compat.h"

#include "sct_rules/loguser.h"
#include "sct_rules/membuf.h"

struct sct_log_dev_type {
	sct_loguser_t* loguser_head;
	size_t num_logusers;
	wait_queue_head_t wait;	
};

int init_log_dev_file(sct_log_dev_t** dev); 

void destroy_log_dev_file(sct_log_dev_t* dev); 

void wake_up_logger(void); 

sct_loguser_t* create_loguser(void);

void destroy_loguser(sct_loguser_t* loguser);

sct_loguser_t* get_last_loguser(void);

sct_loguser_t* get_prev_loguser(sct_loguser_t* cur);


extern sct_log_dev_t log_dev; 

#endif /* CTRL_DEV_H_ */ 
