#!/usr/bin/perl

use strict;

require 5.004; 
#BEGIN {  unshift @INC, "../lib"; }

$^W = 0;
use Parse::YYLex;
use SctParser;

my @token = (
         "LSHIFT", '<<',
         "RSHIFT", '>>',
         "LOGICAL_OR", '\|\|',
         "LOGICAL_AND", '&&',
         "LE", '<=',
         "GE", '>=',
         "NE", '!=',
         "EQ", '==',
         "LT", '<',
         "GT", '>',
         "DOT", '\.',
         "ADDOP",    '[-+]',
         "MULTOP",   '[\*/]',
         "LEFTP"  ,  '[\(]',
         "RIGHTP"  , '[\)]',
         "LEFTSB",   '\[',
         "RIGHTSB",   '\]',
         "RIGHTCB",    '\}',
         "BITAND",  '&',
         "BITOR",  '\|',
         "BITXOR",   '\^',
         "BITNOT",   '~',
         "INTEGER" , '[1-9][0-9]*',
         "HEXINT", '0x[A-Fa-f0-9]+',
         "OCTINT", '0[0-7]*',
         # We can use this regexp because a starting integer is
         # already processed.
         "IDENT", '[A-Za-z_]\w*',
         "DOT",    '\.',
         "EOL" , '\n',
         # This makes sure the string may contain double-quotes preceded
         # by a backslash.
         "STRING",   '"(?:[^"]*\\")*[^"]*"',
         qw(ERROR  .*), sub {
            die "!can\'t analyze: \"$_[1]\"\n!";
          }
     );

Parse::YYLex->trace;
Parse::YYLex->ytab('y.tab.ph');
my $lexer = Parse::YYLex->new(@token);

my $debug = 0;

sub yyerror
{
    die "There was an error:" . join("\n", @_). "\n";
}

my $parser = new SctParser($lexer->getyylex(), \&yyerror , $debug);
$lexer->from(\*STDIN);
$parser->yyparse(\*STDIN);


__END__
1+2-5
5==6
5<6
700==PID
PARAMS[6]==7
H == 6
PARAMS[2].tz_minuteswest == 0
PARAMS[1]=="/etc/passwd"
H=="String with a \"quote\""
(h&7)>>1==1
PARAMS[1]=="/etc/passwd" && PID < 900
H==5 } 6
y==9+3
