/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 Muli Ben-Yehuda, mulix@actcom.co.il	    */
/* License: GNU Lesser General Public License                       */

/* 
 * $Id: sysctl_private.c,v 1.3 2003/01/31 14:08:44 mulix Exp $
 */

#include "sct_rules/membuf.h" 

#include <linux/unistd.h> 
#include <linux/sysctl.h> 

#include <string.h> 
#include <stdio.h> 
#include <assert.h> 

_syscall1(int, _sysctl, struct __sysctl_args *, args);

struct sct_ctrl_type; 

/* returns 0 on error and 1 on success */
int do_sysctl(struct sct_membuf* m, int* sysctl_cmd, 
	      unsigned int sysctl_cmd_len,
	      void* oldval, size_t* oldlenp)
{
	struct __sysctl_args args; 
	int rc;
    
	assert (sysctl_cmd);
    
	if (!sysctl_cmd)
		return 0;

	memset(&args, 0, sizeof(args)); 

	args.name = sysctl_cmd; 
	args.nlen = sysctl_cmd_len; 
	args.oldval = oldval; 
	args.oldlenp = oldlenp; 
	args.newval = (m ? sct_membuf_get_data(m) : NULL); 
	args.newlen = (m ? sct_membuf_available_for_read(m) : 0); 

	rc = _sysctl(&args);
	if (rc < 0) 
		perror("sysctl");
	
	return rc; 
}

