/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 Muli Ben-Yehuda, mulix@actcom.co.il	    */
/* License: GNU General Public License                              */

/*
 *$Id: sstreamwrap.h,v 1.2 2003/01/28 17:49:01 mulix Exp $
 */

#ifndef SSTREAMWRAP_H_
#define SSTREAMWRAP_H_ 

#include <string> 

#if __GNUC__ >= 3

#include <sstream>

class sstreamwrap: public std::stringstream
{
 public: 
	std::string str() 
	{ 
		*this << std::ends; 
		return std::stringstream::str(); 
	} 
}; 

# else /* __GNUC__ < 3 */ 

#include <strstream>

class sstreamwrap: public std::strstream
{
 public: 
	std::string str() 
	{ 
		*this << std::ends; 
		string s(std::strstream::str()); 
		freeze(0); 
		return s; 
	}
}; 

#endif /* __GNUC__ >= 3 */ 

#endif /* SSTREAMWRAP_H_ */ 
