/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 Muli Ben-Yehuda, mulix@actcom.co.il	    */
/* License: GNU Lesser General Public License                       */

/*
 *$Id: arch-userspace.h,v 1.12 2003/01/28 13:48:50 mulix Exp $
 */
#ifndef ARCH_USERSPACE_H_
#define ARCH_USERSPACE_H_

/* malloc/free support */
# include <malloc.h>
# include <unistd.h>
# include <string.h>
# include <stdio.h>
# include <assert.h>
# include <ctype.h>
# include <stdarg.h>
# include <errno.h>
# include <signal.h> 
# include <sys/types.h>

# define mem_alloc(foo)  malloc((foo))
# define mem_free(foo)   free((foo))
# define vmem_alloc(foo) malloc((foo))
# define vmem_free(foo)  free((foo))

/* generic printing macro */
# define PPRINT(fmt, args...) printf(fmt, ## args)

#ifndef asmlinkage 
# define asmlinkage __attribute__((regparm(0)))
#endif /* amslinkage */ 

typedef void* sct_sem_t;

static inline pid_t sct_getpid(void)
{
	return getpid(); 
}

static inline int sct_kill(pid_t pid, int sig)
{
	return kill(pid, sig); 
}

static inline void sct_suspend(pid_t pid)
{
        kill(pid,SIGSTOP);
}

/* loguser lock and unlock functions */
static inline int sct_lock_sem_interruptible(void* sem)
{
	return 0;
}

static inline void sct_lock_sem(void* sem)
{
}

static inline void sct_unlock_sem(void* sem)
{
	/* nothing */
}

static inline void sct_sema_init(void* sem, int val)
{
        /* nothing */
}

#endif /* ARCH_USERSPACE_H_ */

