/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 Itai Segall, spapuk@t2.technion.ac.il    */
/* License: GNU Lesser General Public License                       */

/*
 *$Id: loguser.h,v 1.5 2003/01/29 15:47:33 mulix Exp $
 */

#ifndef LOGUSER_H_
#define LOGUSER_H_

#include "archdep.h"
#include "rule_engine_public.h"

#define DEFAULT_LOG_FORMAT NULL

sct_loguser_t* sct_loguser_create(struct sct_membuf* rng, char* before_format,
				  char* after_format);

void sct_loguser_destroy(sct_loguser_t* buf);

struct sct_membuf* sct_loguser_get_membuf(sct_loguser_t* loguser);

const char* sct_loguser_get_log_format(sct_loguser_t* loguser,
				       sct_rule_when_t when);

char* sct_loguser_change_log_format(sct_loguser_t* loguser, 
				   sct_rule_when_t when, char* format);

sct_loguser_t* sct_loguser_get_next(sct_loguser_t* loguser);

void sct_loguser_set_next(sct_loguser_t* cur, sct_loguser_t* nxt);

unsigned int sct_loguser_get_max_record_len(sct_loguser_t* loguser); 

unsigned int sct_loguser_set_max_record_len(sct_loguser_t* loguser, 
					    unsigned int val); 

int lock_loguser_interruptible(sct_loguser_t* loguser); 

void lock_loguser(sct_loguser_t* loguser);

void unlock_loguser(sct_loguser_t* loguser);

#endif /* LOGUSER_H_ */
