/* 
 * TEST_TITLE: fork (match any fork)
 * TEST_SYSCALL: fork
 * TEST_WHEN: before
 * TEST_RULE_1: 1
 * TEST_EXPECT: 1
 * TEST_TIMEOUT: 10
 * TEST_END
 *
 * TEST_TITLE: execve (match "/bin/ls")
 * TEST_SYSCALL: execve
 * TEST_WHEN: before
 * TEST_RULE_1: (PARAMS[1] == "/bin/ls")
 * TEST_RULE_2: 1
 * TEST_EXPECT_PARAMS: /bin/ls
 * TEST_EXPECT: 1
 * TEST_TIMEOUT: 10
 * TEST_END
 *
 */

#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>

int main(int argc, char** argv, char** envp)
{
	pid_t p = fork(); 
	if (p == -1)
		return 0; 
	if (p == 0) {/* son */ 
		int fd = open("/dev/null", 0);
		dup2(fd, fileno(stdout)); 
		dup2(fd, fileno(stderr)); 
		execve("/bin/ls", argv, envp); 
	}
	return 0; 
}
