/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2003 Muli Ben-Yehuda, mulix@mulix.org         */ 
/* License: GNU General Public License                              */

/* 
 * $Id: tests.h,v 1.1 2003/01/31 18:35:32 mulix Exp $
 */ 

#ifndef TESTS_H_
#define TESTS_H_

int test_all_syscalls_register_rules(void); 
int test_simple_syscall_usage(void);
int test_rule_register_deregister(void);
int test_loguser(void);
int test_all_syscalls_usage(void);
int test_settimeofday_usage(void);
int test_filter_eval_bit(void);
int test_eval_complex_filter(void);
int test_filter_serialize_deserialize(void);
int test_rules_serialize_deserialize(void);
int test_tracking_rule_add_delete(void);
int test_tracking_rule_add_delete_empty_list(void);
int test_indexed_field_variables(void);
int test_kernel_variables(void);
int test_short_circuiting(void);
int test_filter_node_vectors(void);
int test_filter_node_in_match(void); 
int test_membuf(void); 
int test_tracking_rule_list(void); 
int test_logging(void); 
int test_get_rules(void); 
int test_void_ptr_buffer(void); 
int test_buffer_match(void); 
int test_membuf_enlarge(void); 
int test_membuf_resize(void);
int test_ring_membuf_exact(void); 
int test_ring_membuf_drop_new(void); 
int test_ring_membuf_drop_old(void); 
int test_cyclic_membuf(void); 
int test_logging_cyclic(void); 
int test_struct(void); 
int test_long_long(void); 
int test_void_ptr(void); 
int test_kill_suspend_process(void);
int test_filter_node_in_match(void); 
int test_vector_kernel_vars(void); 
int test_ancestors_simple(void); 
int test_serialize_vectors(void); 

#define SCT_SUBSYS_MODULE         (1 << 0)
#define SCT_SUBSYS_RULES          (1 << 1)

#define SCT_SUBSYS_BITS           (SCT_SUBSYS_MODULE | SCT_SUBSYS_RULES)

#define SCT_TEST_REPEATABLE       (1 << 2)

#define SCT_TEST_REPEATABLE_BITS  (SCT_TEST_REPEATABLE)

struct test {
	char* name; 
	unsigned int flags; 
	int (*test_fn)(void); 
}; 

extern struct test tests[]; 

const char* subsystem_as_str(unsigned int subsys); 

unsigned int str_to_subsystem(const char* str); 

/* returns the number of tests found */ 
unsigned int find_test(const char* name, struct test** test); 

void list_tests(FILE* f); 

#endif /* TESTS_H_ */ 
