/*
 * $Id: syscall_hijack_autogen.c,v 1.28 2003/02/03 11:36:59 mulix Exp $
 */

/* This file is automatically generated - do not edit. */
/* built by './gen_syscalls.pl 256' for Linux. */


#include <asm/errno.h>

#include <linux/types.h>
#include <linux/time.h>
#include <linux/times.h>
#include <linux/socket.h>
#include <linux/in.h>
#include <linux/utime.h>
#include <linux/utsname.h>
#include <linux/stat.h>
#include <linux/resource.h>
#include <linux/signal.h>
#include <linux/stddef.h>
#include <linux/module.h>
#include <asm/stat.h>
#include <asm/statfs.h>
#include <linux/mm.h>
#include <linux/shm.h>
#include <linux/poll.h>
#include <linux/sysctl.h>
#if defined (KERNEL_24)
#include <linux/shmem_fs.h>
#endif


/* these structures are declared inside the .c file */
/* in the kernel, so we copy them here. yuck. */   
/* needless to say, if they change for any reason, this breaks */ 
/* horrily */ 
struct sel_arg_struct { 
unsigned long n; 
fd_set *inp, *outp, *exp; 
struct timeval *tvp; 
};

struct mmap_arg_struct { 
unsigned long addr; 
unsigned long len; 
unsigned long prot; 
unsigned long flags; 
unsigned long fd; 
unsigned long offset; 
};

/*
 * Stub functions for syscall hijacking.
 */

/* stub function for syscall 'read' (3). */
asmlinkage static int
stub_syscall_3(int fd, void* buf, size_t count) {
	typedef int 
		(*stub_func_3)(int fd, void* buf, size_t count);
	typedef int
		(*stub_before_func_3)(int fd, void* buf, size_t count, int* syscall_rc); 
	typedef int
		(*stub_after_func_3)(int syscall_rc, int fd, void* buf, size_t count);

	stub_func_3 orig_syscall_func;
	stub_before_func_3 before_func;
	stub_after_func_3 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[3];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_3)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_3)hdata->orig_syscall;
	after_func = (stub_after_func_3)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, buf, count , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, buf, count) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, buf, count);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 3, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'write' (4). */
asmlinkage static int
stub_syscall_4(int fd, void* buf, size_t count) {
	typedef int 
		(*stub_func_4)(int fd, void* buf, size_t count);
	typedef int
		(*stub_before_func_4)(int fd, void* buf, size_t count, int* syscall_rc); 
	typedef int
		(*stub_after_func_4)(int syscall_rc, int fd, void* buf, size_t count);

	stub_func_4 orig_syscall_func;
	stub_before_func_4 before_func;
	stub_after_func_4 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[4];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_4)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_4)hdata->orig_syscall;
	after_func = (stub_after_func_4)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, buf, count , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, buf, count) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, buf, count);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 4, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'open' (5). */
asmlinkage static int
stub_syscall_5(const char* pathname, int flags, mode_t mode) {
	typedef int 
		(*stub_func_5)(const char* pathname, int flags, mode_t mode);
	typedef int
		(*stub_before_func_5)(const char* pathname, int flags, mode_t mode, int* syscall_rc); 
	typedef int
		(*stub_after_func_5)(int syscall_rc, const char* pathname, int flags, mode_t mode);

	stub_func_5 orig_syscall_func;
	stub_before_func_5 before_func;
	stub_after_func_5 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[5];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_5)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_5)hdata->orig_syscall;
	after_func = (stub_after_func_5)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pathname, flags, mode , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pathname, flags, mode) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pathname, flags, mode);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 5, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'close' (6). */
asmlinkage static int
stub_syscall_6(int fd) {
	typedef int 
		(*stub_func_6)(int fd);
	typedef int
		(*stub_before_func_6)(int fd, int* syscall_rc); 
	typedef int
		(*stub_after_func_6)(int syscall_rc, int fd);

	stub_func_6 orig_syscall_func;
	stub_before_func_6 before_func;
	stub_after_func_6 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[6];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_6)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_6)hdata->orig_syscall;
	after_func = (stub_after_func_6)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 6, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'waitpid' (7). */
asmlinkage static int
stub_syscall_7(pid_t pid, int* status, int options) {
	typedef int 
		(*stub_func_7)(pid_t pid, int* status, int options);
	typedef int
		(*stub_before_func_7)(pid_t pid, int* status, int options, int* syscall_rc); 
	typedef int
		(*stub_after_func_7)(int syscall_rc, pid_t pid, int* status, int options);

	stub_func_7 orig_syscall_func;
	stub_before_func_7 before_func;
	stub_after_func_7 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[7];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_7)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_7)hdata->orig_syscall;
	after_func = (stub_after_func_7)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pid, status, options , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pid, status, options) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pid, status, options);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 7, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'creat' (8). */
asmlinkage static int
stub_syscall_8(const char* pathname, mode_t mode) {
	typedef int 
		(*stub_func_8)(const char* pathname, mode_t mode);
	typedef int
		(*stub_before_func_8)(const char* pathname, mode_t mode, int* syscall_rc); 
	typedef int
		(*stub_after_func_8)(int syscall_rc, const char* pathname, mode_t mode);

	stub_func_8 orig_syscall_func;
	stub_before_func_8 before_func;
	stub_after_func_8 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[8];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_8)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_8)hdata->orig_syscall;
	after_func = (stub_after_func_8)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pathname, mode , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pathname, mode) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pathname, mode);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 8, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'link' (9). */
asmlinkage static int
stub_syscall_9(const char* oldpath, const char* newpath) {
	typedef int 
		(*stub_func_9)(const char* oldpath, const char* newpath);
	typedef int
		(*stub_before_func_9)(const char* oldpath, const char* newpath, int* syscall_rc); 
	typedef int
		(*stub_after_func_9)(int syscall_rc, const char* oldpath, const char* newpath);

	stub_func_9 orig_syscall_func;
	stub_before_func_9 before_func;
	stub_after_func_9 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[9];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_9)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_9)hdata->orig_syscall;
	after_func = (stub_after_func_9)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(oldpath, newpath , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(oldpath, newpath) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, oldpath, newpath);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 9, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'unlink' (10). */
asmlinkage static int
stub_syscall_10(const char* pathname) {
	typedef int 
		(*stub_func_10)(const char* pathname);
	typedef int
		(*stub_before_func_10)(const char* pathname, int* syscall_rc); 
	typedef int
		(*stub_after_func_10)(int syscall_rc, const char* pathname);

	stub_func_10 orig_syscall_func;
	stub_before_func_10 before_func;
	stub_after_func_10 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[10];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_10)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_10)hdata->orig_syscall;
	after_func = (stub_after_func_10)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pathname , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pathname) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pathname);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 10, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'chdir' (12). */
asmlinkage static int
stub_syscall_12(const char* pathname) {
	typedef int 
		(*stub_func_12)(const char* pathname);
	typedef int
		(*stub_before_func_12)(const char* pathname, int* syscall_rc); 
	typedef int
		(*stub_after_func_12)(int syscall_rc, const char* pathname);

	stub_func_12 orig_syscall_func;
	stub_before_func_12 before_func;
	stub_after_func_12 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[12];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_12)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_12)hdata->orig_syscall;
	after_func = (stub_after_func_12)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pathname , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pathname) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pathname);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 12, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'time' (13). */
asmlinkage static int
stub_syscall_13(time_t* time) {
	typedef int 
		(*stub_func_13)(time_t* time);
	typedef int
		(*stub_before_func_13)(time_t* time, int* syscall_rc); 
	typedef int
		(*stub_after_func_13)(int syscall_rc, time_t* time);

	stub_func_13 orig_syscall_func;
	stub_before_func_13 before_func;
	stub_after_func_13 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[13];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_13)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_13)hdata->orig_syscall;
	after_func = (stub_after_func_13)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(time , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(time) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, time);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 13, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'mknod' (14). */
asmlinkage static int
stub_syscall_14(const char* pathname, mode_t mode, dev_t dev) {
	typedef int 
		(*stub_func_14)(const char* pathname, mode_t mode, dev_t dev);
	typedef int
		(*stub_before_func_14)(const char* pathname, mode_t mode, dev_t dev, int* syscall_rc); 
	typedef int
		(*stub_after_func_14)(int syscall_rc, const char* pathname, mode_t mode, dev_t dev);

	stub_func_14 orig_syscall_func;
	stub_before_func_14 before_func;
	stub_after_func_14 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[14];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_14)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_14)hdata->orig_syscall;
	after_func = (stub_after_func_14)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pathname, mode, dev , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pathname, mode, dev) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pathname, mode, dev);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 14, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'chmod' (15). */
asmlinkage static int
stub_syscall_15(const char* pathname, mode_t mode) {
	typedef int 
		(*stub_func_15)(const char* pathname, mode_t mode);
	typedef int
		(*stub_before_func_15)(const char* pathname, mode_t mode, int* syscall_rc); 
	typedef int
		(*stub_after_func_15)(int syscall_rc, const char* pathname, mode_t mode);

	stub_func_15 orig_syscall_func;
	stub_before_func_15 before_func;
	stub_after_func_15 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[15];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_15)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_15)hdata->orig_syscall;
	after_func = (stub_after_func_15)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pathname, mode , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pathname, mode) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pathname, mode);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 15, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'lchown16' (16). */
asmlinkage static int
stub_syscall_16(const char* filename, unsigned short user, unsigned short group) {
	typedef int 
		(*stub_func_16)(const char* filename, unsigned short user, unsigned short group);
	typedef int
		(*stub_before_func_16)(const char* filename, unsigned short user, unsigned short group, int* syscall_rc); 
	typedef int
		(*stub_after_func_16)(int syscall_rc, const char* filename, unsigned short user, unsigned short group);

	stub_func_16 orig_syscall_func;
	stub_before_func_16 before_func;
	stub_after_func_16 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[16];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_16)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_16)hdata->orig_syscall;
	after_func = (stub_after_func_16)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(filename, user, group , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(filename, user, group) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, filename, user, group);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 16, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'stat' (18). */
asmlinkage static int
stub_syscall_18(const char* file_name, struct __old_kernel_stat* buf) {
	typedef int 
		(*stub_func_18)(const char* file_name, struct __old_kernel_stat* buf);
	typedef int
		(*stub_before_func_18)(const char* file_name, struct __old_kernel_stat* buf, int* syscall_rc); 
	typedef int
		(*stub_after_func_18)(int syscall_rc, const char* file_name, struct __old_kernel_stat* buf);

	stub_func_18 orig_syscall_func;
	stub_before_func_18 before_func;
	stub_after_func_18 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[18];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_18)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_18)hdata->orig_syscall;
	after_func = (stub_after_func_18)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(file_name, buf , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(file_name, buf) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, file_name, buf);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 18, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'lseek' (19). */
asmlinkage static int
stub_syscall_19(int fildes, off_t offset, int whence) {
	typedef int 
		(*stub_func_19)(int fildes, off_t offset, int whence);
	typedef int
		(*stub_before_func_19)(int fildes, off_t offset, int whence, int* syscall_rc); 
	typedef int
		(*stub_after_func_19)(int syscall_rc, int fildes, off_t offset, int whence);

	stub_func_19 orig_syscall_func;
	stub_before_func_19 before_func;
	stub_after_func_19 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[19];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_19)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_19)hdata->orig_syscall;
	after_func = (stub_after_func_19)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fildes, offset, whence , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fildes, offset, whence) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fildes, offset, whence);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 19, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getpid' (20). */
asmlinkage static int
stub_syscall_20(void) {
	typedef int 
		(*stub_func_20)(void);
	typedef int
		(*stub_before_func_20)(int* syscall_rc); 
	typedef int
		(*stub_after_func_20)(int syscall_rc);

	stub_func_20 orig_syscall_func;
	stub_before_func_20 before_func;
	stub_after_func_20 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[20];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_20)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_20)hdata->orig_syscall;
	after_func = (stub_after_func_20)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)( &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)() 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval );
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 20, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'mount' (21). */
asmlinkage static int
stub_syscall_21(const char* source, const char* target, const char* filesystemtype, unsigned long mountflags, void* data) {
	typedef int 
		(*stub_func_21)(const char* source, const char* target, const char* filesystemtype, unsigned long mountflags, void* data);
	typedef int
		(*stub_before_func_21)(const char* source, const char* target, const char* filesystemtype, unsigned long mountflags, void* data, int* syscall_rc); 
	typedef int
		(*stub_after_func_21)(int syscall_rc, const char* source, const char* target, const char* filesystemtype, unsigned long mountflags, void* data);

	stub_func_21 orig_syscall_func;
	stub_before_func_21 before_func;
	stub_after_func_21 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[21];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_21)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_21)hdata->orig_syscall;
	after_func = (stub_after_func_21)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(source, target, filesystemtype, mountflags, data , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(source, target, filesystemtype, mountflags, data) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, source, target, filesystemtype, mountflags, data);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 21, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'oldumount' (22). */
asmlinkage static int
stub_syscall_22(char* name) {
	typedef int 
		(*stub_func_22)(char* name);
	typedef int
		(*stub_before_func_22)(char* name, int* syscall_rc); 
	typedef int
		(*stub_after_func_22)(int syscall_rc, char* name);

	stub_func_22 orig_syscall_func;
	stub_before_func_22 before_func;
	stub_after_func_22 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[22];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_22)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_22)hdata->orig_syscall;
	after_func = (stub_after_func_22)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(name , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(name) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, name);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 22, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setuid16' (23). */
asmlinkage static int
stub_syscall_23(unsigned short uid) {
	typedef int 
		(*stub_func_23)(unsigned short uid);
	typedef int
		(*stub_before_func_23)(unsigned short uid, int* syscall_rc); 
	typedef int
		(*stub_after_func_23)(int syscall_rc, unsigned short uid);

	stub_func_23 orig_syscall_func;
	stub_before_func_23 before_func;
	stub_after_func_23 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[23];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_23)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_23)hdata->orig_syscall;
	after_func = (stub_after_func_23)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(uid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(uid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, uid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 23, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getuid16' (24). */
asmlinkage static int
stub_syscall_24(unsigned short gid) {
	typedef int 
		(*stub_func_24)(unsigned short gid);
	typedef int
		(*stub_before_func_24)(unsigned short gid, int* syscall_rc); 
	typedef int
		(*stub_after_func_24)(int syscall_rc, unsigned short gid);

	stub_func_24 orig_syscall_func;
	stub_before_func_24 before_func;
	stub_after_func_24 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[24];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_24)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_24)hdata->orig_syscall;
	after_func = (stub_after_func_24)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(gid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(gid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, gid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 24, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'stime' (25). */
asmlinkage static int
stub_syscall_25(time_t* time) {
	typedef int 
		(*stub_func_25)(time_t* time);
	typedef int
		(*stub_before_func_25)(time_t* time, int* syscall_rc); 
	typedef int
		(*stub_after_func_25)(int syscall_rc, time_t* time);

	stub_func_25 orig_syscall_func;
	stub_before_func_25 before_func;
	stub_after_func_25 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[25];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_25)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_25)hdata->orig_syscall;
	after_func = (stub_after_func_25)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(time , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(time) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, time);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 25, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'ptrace' (26). */
asmlinkage static int
stub_syscall_26(long request, long pid, long addr, long data) {
	typedef int 
		(*stub_func_26)(long request, long pid, long addr, long data);
	typedef int
		(*stub_before_func_26)(long request, long pid, long addr, long data, int* syscall_rc); 
	typedef int
		(*stub_after_func_26)(int syscall_rc, long request, long pid, long addr, long data);

	stub_func_26 orig_syscall_func;
	stub_before_func_26 before_func;
	stub_after_func_26 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[26];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_26)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_26)hdata->orig_syscall;
	after_func = (stub_after_func_26)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(request, pid, addr, data , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(request, pid, addr, data) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, request, pid, addr, data);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 26, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'alarm' (27). */
asmlinkage static int
stub_syscall_27(unsigned int seconds) {
	typedef int 
		(*stub_func_27)(unsigned int seconds);
	typedef int
		(*stub_before_func_27)(unsigned int seconds, int* syscall_rc); 
	typedef int
		(*stub_after_func_27)(int syscall_rc, unsigned int seconds);

	stub_func_27 orig_syscall_func;
	stub_before_func_27 before_func;
	stub_after_func_27 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[27];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_27)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_27)hdata->orig_syscall;
	after_func = (stub_after_func_27)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(seconds , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(seconds) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, seconds);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 27, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'fstat' (28). */
asmlinkage static int
stub_syscall_28(int filedes, struct __old_kernel_stat* buf) {
	typedef int 
		(*stub_func_28)(int filedes, struct __old_kernel_stat* buf);
	typedef int
		(*stub_before_func_28)(int filedes, struct __old_kernel_stat* buf, int* syscall_rc); 
	typedef int
		(*stub_after_func_28)(int syscall_rc, int filedes, struct __old_kernel_stat* buf);

	stub_func_28 orig_syscall_func;
	stub_before_func_28 before_func;
	stub_after_func_28 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[28];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_28)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_28)hdata->orig_syscall;
	after_func = (stub_after_func_28)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(filedes, buf , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(filedes, buf) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, filedes, buf);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 28, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'pause' (29). */
asmlinkage static int
stub_syscall_29(void) {
	typedef int 
		(*stub_func_29)(void);
	typedef int
		(*stub_before_func_29)(int* syscall_rc); 
	typedef int
		(*stub_after_func_29)(int syscall_rc);

	stub_func_29 orig_syscall_func;
	stub_before_func_29 before_func;
	stub_after_func_29 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[29];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_29)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_29)hdata->orig_syscall;
	after_func = (stub_after_func_29)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)( &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)() 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval );
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 29, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'utime' (30). */
asmlinkage static int
stub_syscall_30(const char* filename, struct utimbuf* buf) {
	typedef int 
		(*stub_func_30)(const char* filename, struct utimbuf* buf);
	typedef int
		(*stub_before_func_30)(const char* filename, struct utimbuf* buf, int* syscall_rc); 
	typedef int
		(*stub_after_func_30)(int syscall_rc, const char* filename, struct utimbuf* buf);

	stub_func_30 orig_syscall_func;
	stub_before_func_30 before_func;
	stub_after_func_30 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[30];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_30)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_30)hdata->orig_syscall;
	after_func = (stub_after_func_30)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(filename, buf , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(filename, buf) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, filename, buf);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 30, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'access' (33). */
asmlinkage static int
stub_syscall_33(const char* pathname, int mode) {
	typedef int 
		(*stub_func_33)(const char* pathname, int mode);
	typedef int
		(*stub_before_func_33)(const char* pathname, int mode, int* syscall_rc); 
	typedef int
		(*stub_after_func_33)(int syscall_rc, const char* pathname, int mode);

	stub_func_33 orig_syscall_func;
	stub_before_func_33 before_func;
	stub_after_func_33 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[33];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_33)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_33)hdata->orig_syscall;
	after_func = (stub_after_func_33)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pathname, mode , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pathname, mode) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pathname, mode);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 33, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'nice' (34). */
asmlinkage static int
stub_syscall_34(int inc) {
	typedef int 
		(*stub_func_34)(int inc);
	typedef int
		(*stub_before_func_34)(int inc, int* syscall_rc); 
	typedef int
		(*stub_after_func_34)(int syscall_rc, int inc);

	stub_func_34 orig_syscall_func;
	stub_before_func_34 before_func;
	stub_after_func_34 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[34];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_34)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_34)hdata->orig_syscall;
	after_func = (stub_after_func_34)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(inc , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(inc) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, inc);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 34, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sync' (36). */
asmlinkage static int
stub_syscall_36(void) {
	typedef int 
		(*stub_func_36)(void);
	typedef int
		(*stub_before_func_36)(int* syscall_rc); 
	typedef int
		(*stub_after_func_36)(int syscall_rc);

	stub_func_36 orig_syscall_func;
	stub_before_func_36 before_func;
	stub_after_func_36 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[36];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_36)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_36)hdata->orig_syscall;
	after_func = (stub_after_func_36)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)( &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)() 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval );
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 36, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'kill' (37). */
asmlinkage static int
stub_syscall_37(pid_t pid, int sig) {
	typedef int 
		(*stub_func_37)(pid_t pid, int sig);
	typedef int
		(*stub_before_func_37)(pid_t pid, int sig, int* syscall_rc); 
	typedef int
		(*stub_after_func_37)(int syscall_rc, pid_t pid, int sig);

	stub_func_37 orig_syscall_func;
	stub_before_func_37 before_func;
	stub_after_func_37 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[37];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_37)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_37)hdata->orig_syscall;
	after_func = (stub_after_func_37)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pid, sig , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pid, sig) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pid, sig);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 37, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'rename' (38). */
asmlinkage static int
stub_syscall_38(const char* oldpath, const char* newpath) {
	typedef int 
		(*stub_func_38)(const char* oldpath, const char* newpath);
	typedef int
		(*stub_before_func_38)(const char* oldpath, const char* newpath, int* syscall_rc); 
	typedef int
		(*stub_after_func_38)(int syscall_rc, const char* oldpath, const char* newpath);

	stub_func_38 orig_syscall_func;
	stub_before_func_38 before_func;
	stub_after_func_38 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[38];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_38)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_38)hdata->orig_syscall;
	after_func = (stub_after_func_38)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(oldpath, newpath , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(oldpath, newpath) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, oldpath, newpath);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 38, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'mkdir' (39). */
asmlinkage static int
stub_syscall_39(const char* pathname, mode_t mode) {
	typedef int 
		(*stub_func_39)(const char* pathname, mode_t mode);
	typedef int
		(*stub_before_func_39)(const char* pathname, mode_t mode, int* syscall_rc); 
	typedef int
		(*stub_after_func_39)(int syscall_rc, const char* pathname, mode_t mode);

	stub_func_39 orig_syscall_func;
	stub_before_func_39 before_func;
	stub_after_func_39 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[39];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_39)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_39)hdata->orig_syscall;
	after_func = (stub_after_func_39)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pathname, mode , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pathname, mode) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pathname, mode);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 39, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'rmdir' (40). */
asmlinkage static int
stub_syscall_40(const char* pathname) {
	typedef int 
		(*stub_func_40)(const char* pathname);
	typedef int
		(*stub_before_func_40)(const char* pathname, int* syscall_rc); 
	typedef int
		(*stub_after_func_40)(int syscall_rc, const char* pathname);

	stub_func_40 orig_syscall_func;
	stub_before_func_40 before_func;
	stub_after_func_40 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[40];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_40)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_40)hdata->orig_syscall;
	after_func = (stub_after_func_40)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pathname , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pathname) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pathname);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 40, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'dup' (41). */
asmlinkage static int
stub_syscall_41(int oldfd) {
	typedef int 
		(*stub_func_41)(int oldfd);
	typedef int
		(*stub_before_func_41)(int oldfd, int* syscall_rc); 
	typedef int
		(*stub_after_func_41)(int syscall_rc, int oldfd);

	stub_func_41 orig_syscall_func;
	stub_before_func_41 before_func;
	stub_after_func_41 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[41];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_41)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_41)hdata->orig_syscall;
	after_func = (stub_after_func_41)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(oldfd , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(oldfd) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, oldfd);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 41, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'pipe' (42). */
asmlinkage static int
stub_syscall_42(int filedes[2]) {
	typedef int 
		(*stub_func_42)(int filedes[2]);
	typedef int
		(*stub_before_func_42)(int filedes[2], int* syscall_rc); 
	typedef int
		(*stub_after_func_42)(int syscall_rc, int filedes[2]);

	stub_func_42 orig_syscall_func;
	stub_before_func_42 before_func;
	stub_after_func_42 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[42];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_42)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_42)hdata->orig_syscall;
	after_func = (stub_after_func_42)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(filedes , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(filedes) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, filedes);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 42, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'times' (43). */
asmlinkage static int
stub_syscall_43(struct tms* buf) {
	typedef int 
		(*stub_func_43)(struct tms* buf);
	typedef int
		(*stub_before_func_43)(struct tms* buf, int* syscall_rc); 
	typedef int
		(*stub_after_func_43)(int syscall_rc, struct tms* buf);

	stub_func_43 orig_syscall_func;
	stub_before_func_43 before_func;
	stub_after_func_43 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[43];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_43)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_43)hdata->orig_syscall;
	after_func = (stub_after_func_43)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(buf , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(buf) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, buf);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 43, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'brk' (45). */
asmlinkage static int
stub_syscall_45(void* end_data_segment) {
	typedef int 
		(*stub_func_45)(void* end_data_segment);
	typedef int
		(*stub_before_func_45)(void* end_data_segment, int* syscall_rc); 
	typedef int
		(*stub_after_func_45)(int syscall_rc, void* end_data_segment);

	stub_func_45 orig_syscall_func;
	stub_before_func_45 before_func;
	stub_after_func_45 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[45];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_45)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_45)hdata->orig_syscall;
	after_func = (stub_after_func_45)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(end_data_segment , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(end_data_segment) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, end_data_segment);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 45, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setgid16' (46). */
asmlinkage static int
stub_syscall_46(unsigned short uid) {
	typedef int 
		(*stub_func_46)(unsigned short uid);
	typedef int
		(*stub_before_func_46)(unsigned short uid, int* syscall_rc); 
	typedef int
		(*stub_after_func_46)(int syscall_rc, unsigned short uid);

	stub_func_46 orig_syscall_func;
	stub_before_func_46 before_func;
	stub_after_func_46 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[46];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_46)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_46)hdata->orig_syscall;
	after_func = (stub_after_func_46)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(uid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(uid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, uid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 46, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getgid16' (47). */
asmlinkage static int
stub_syscall_47(void) {
	typedef int 
		(*stub_func_47)(void);
	typedef int
		(*stub_before_func_47)(int* syscall_rc); 
	typedef int
		(*stub_after_func_47)(int syscall_rc);

	stub_func_47 orig_syscall_func;
	stub_before_func_47 before_func;
	stub_after_func_47 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[47];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_47)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_47)hdata->orig_syscall;
	after_func = (stub_after_func_47)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)( &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)() 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval );
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 47, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'signal' (48). */
asmlinkage static int
stub_syscall_48(int sig, void* handler) {
	typedef int 
		(*stub_func_48)(int sig, void* handler);
	typedef int
		(*stub_before_func_48)(int sig, void* handler, int* syscall_rc); 
	typedef int
		(*stub_after_func_48)(int syscall_rc, int sig, void* handler);

	stub_func_48 orig_syscall_func;
	stub_before_func_48 before_func;
	stub_after_func_48 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[48];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_48)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_48)hdata->orig_syscall;
	after_func = (stub_after_func_48)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(sig, handler , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(sig, handler) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, sig, handler);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 48, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'geteuid16' (49). */
asmlinkage static int
stub_syscall_49(void) {
	typedef int 
		(*stub_func_49)(void);
	typedef int
		(*stub_before_func_49)(int* syscall_rc); 
	typedef int
		(*stub_after_func_49)(int syscall_rc);

	stub_func_49 orig_syscall_func;
	stub_before_func_49 before_func;
	stub_after_func_49 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[49];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_49)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_49)hdata->orig_syscall;
	after_func = (stub_after_func_49)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)( &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)() 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval );
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 49, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getegid16' (50). */
asmlinkage static int
stub_syscall_50(void) {
	typedef int 
		(*stub_func_50)(void);
	typedef int
		(*stub_before_func_50)(int* syscall_rc); 
	typedef int
		(*stub_after_func_50)(int syscall_rc);

	stub_func_50 orig_syscall_func;
	stub_before_func_50 before_func;
	stub_after_func_50 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[50];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_50)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_50)hdata->orig_syscall;
	after_func = (stub_after_func_50)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)( &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)() 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval );
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 50, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'acct' (51). */
asmlinkage static int
stub_syscall_51(const char* name) {
	typedef int 
		(*stub_func_51)(const char* name);
	typedef int
		(*stub_before_func_51)(const char* name, int* syscall_rc); 
	typedef int
		(*stub_after_func_51)(int syscall_rc, const char* name);

	stub_func_51 orig_syscall_func;
	stub_before_func_51 before_func;
	stub_after_func_51 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[51];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_51)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_51)hdata->orig_syscall;
	after_func = (stub_after_func_51)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(name , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(name) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, name);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 51, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'umount' (52). */
asmlinkage static int
stub_syscall_52(char* name, int flags) {
	typedef int 
		(*stub_func_52)(char* name, int flags);
	typedef int
		(*stub_before_func_52)(char* name, int flags, int* syscall_rc); 
	typedef int
		(*stub_after_func_52)(int syscall_rc, char* name, int flags);

	stub_func_52 orig_syscall_func;
	stub_before_func_52 before_func;
	stub_after_func_52 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[52];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_52)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_52)hdata->orig_syscall;
	after_func = (stub_after_func_52)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(name, flags , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(name, flags) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, name, flags);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 52, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'ioctl' (54). */
asmlinkage static int
stub_syscall_54(unsigned int fd, unsigned int cmd, unsigned long arg) {
	typedef int 
		(*stub_func_54)(unsigned int fd, unsigned int cmd, unsigned long arg);
	typedef int
		(*stub_before_func_54)(unsigned int fd, unsigned int cmd, unsigned long arg, int* syscall_rc); 
	typedef int
		(*stub_after_func_54)(int syscall_rc, unsigned int fd, unsigned int cmd, unsigned long arg);

	stub_func_54 orig_syscall_func;
	stub_before_func_54 before_func;
	stub_after_func_54 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[54];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_54)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_54)hdata->orig_syscall;
	after_func = (stub_after_func_54)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, cmd, arg , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, cmd, arg) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, cmd, arg);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 54, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'fcntl' (55). */
asmlinkage static int
stub_syscall_55(unsigned int fd, unsigned int cmd, unsigned long arg) {
	typedef int 
		(*stub_func_55)(unsigned int fd, unsigned int cmd, unsigned long arg);
	typedef int
		(*stub_before_func_55)(unsigned int fd, unsigned int cmd, unsigned long arg, int* syscall_rc); 
	typedef int
		(*stub_after_func_55)(int syscall_rc, unsigned int fd, unsigned int cmd, unsigned long arg);

	stub_func_55 orig_syscall_func;
	stub_before_func_55 before_func;
	stub_after_func_55 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[55];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_55)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_55)hdata->orig_syscall;
	after_func = (stub_after_func_55)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, cmd, arg , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, cmd, arg) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, cmd, arg);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 55, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setpgid' (57). */
asmlinkage static int
stub_syscall_57(pid_t pid, pid_t pgid) {
	typedef int 
		(*stub_func_57)(pid_t pid, pid_t pgid);
	typedef int
		(*stub_before_func_57)(pid_t pid, pid_t pgid, int* syscall_rc); 
	typedef int
		(*stub_after_func_57)(int syscall_rc, pid_t pid, pid_t pgid);

	stub_func_57 orig_syscall_func;
	stub_before_func_57 before_func;
	stub_after_func_57 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[57];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_57)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_57)hdata->orig_syscall;
	after_func = (stub_after_func_57)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pid, pgid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pid, pgid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pid, pgid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 57, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'olduname' (59). */
asmlinkage static int
stub_syscall_59(struct oldold_utsname* name) {
	typedef int 
		(*stub_func_59)(struct oldold_utsname* name);
	typedef int
		(*stub_before_func_59)(struct oldold_utsname* name, int* syscall_rc); 
	typedef int
		(*stub_after_func_59)(int syscall_rc, struct oldold_utsname* name);

	stub_func_59 orig_syscall_func;
	stub_before_func_59 before_func;
	stub_after_func_59 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[59];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_59)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_59)hdata->orig_syscall;
	after_func = (stub_after_func_59)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(name , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(name) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, name);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 59, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'umask' (60). */
asmlinkage static int
stub_syscall_60(int mask) {
	typedef int 
		(*stub_func_60)(int mask);
	typedef int
		(*stub_before_func_60)(int mask, int* syscall_rc); 
	typedef int
		(*stub_after_func_60)(int syscall_rc, int mask);

	stub_func_60 orig_syscall_func;
	stub_before_func_60 before_func;
	stub_after_func_60 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[60];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_60)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_60)hdata->orig_syscall;
	after_func = (stub_after_func_60)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(mask , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(mask) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, mask);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 60, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'chroot' (61). */
asmlinkage static int
stub_syscall_61(const char* path) {
	typedef int 
		(*stub_func_61)(const char* path);
	typedef int
		(*stub_before_func_61)(const char* path, int* syscall_rc); 
	typedef int
		(*stub_after_func_61)(int syscall_rc, const char* path);

	stub_func_61 orig_syscall_func;
	stub_before_func_61 before_func;
	stub_after_func_61 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[61];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_61)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_61)hdata->orig_syscall;
	after_func = (stub_after_func_61)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(path , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(path) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, path);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 61, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'ustat' (62). */
asmlinkage static int
stub_syscall_62(dev_t dev, struct ustat* ubuf) {
	typedef int 
		(*stub_func_62)(dev_t dev, struct ustat* ubuf);
	typedef int
		(*stub_before_func_62)(dev_t dev, struct ustat* ubuf, int* syscall_rc); 
	typedef int
		(*stub_after_func_62)(int syscall_rc, dev_t dev, struct ustat* ubuf);

	stub_func_62 orig_syscall_func;
	stub_before_func_62 before_func;
	stub_after_func_62 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[62];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_62)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_62)hdata->orig_syscall;
	after_func = (stub_after_func_62)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(dev, ubuf , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(dev, ubuf) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, dev, ubuf);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 62, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'dup2' (63). */
asmlinkage static int
stub_syscall_63(int oldfd, int newfd) {
	typedef int 
		(*stub_func_63)(int oldfd, int newfd);
	typedef int
		(*stub_before_func_63)(int oldfd, int newfd, int* syscall_rc); 
	typedef int
		(*stub_after_func_63)(int syscall_rc, int oldfd, int newfd);

	stub_func_63 orig_syscall_func;
	stub_before_func_63 before_func;
	stub_after_func_63 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[63];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_63)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_63)hdata->orig_syscall;
	after_func = (stub_after_func_63)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(oldfd, newfd , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(oldfd, newfd) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, oldfd, newfd);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 63, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getppid' (64). */
asmlinkage static int
stub_syscall_64(void) {
	typedef int 
		(*stub_func_64)(void);
	typedef int
		(*stub_before_func_64)(int* syscall_rc); 
	typedef int
		(*stub_after_func_64)(int syscall_rc);

	stub_func_64 orig_syscall_func;
	stub_before_func_64 before_func;
	stub_after_func_64 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[64];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_64)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_64)hdata->orig_syscall;
	after_func = (stub_after_func_64)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)( &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)() 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval );
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 64, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getpgrp' (65). */
asmlinkage static int
stub_syscall_65(void) {
	typedef int 
		(*stub_func_65)(void);
	typedef int
		(*stub_before_func_65)(int* syscall_rc); 
	typedef int
		(*stub_after_func_65)(int syscall_rc);

	stub_func_65 orig_syscall_func;
	stub_before_func_65 before_func;
	stub_after_func_65 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[65];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_65)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_65)hdata->orig_syscall;
	after_func = (stub_after_func_65)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)( &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)() 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval );
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 65, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setsid' (66). */
asmlinkage static int
stub_syscall_66(void) {
	typedef int 
		(*stub_func_66)(void);
	typedef int
		(*stub_before_func_66)(int* syscall_rc); 
	typedef int
		(*stub_after_func_66)(int syscall_rc);

	stub_func_66 orig_syscall_func;
	stub_before_func_66 before_func;
	stub_after_func_66 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[66];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_66)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_66)hdata->orig_syscall;
	after_func = (stub_after_func_66)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)( &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)() 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval );
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 66, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sigaction' (67). */
asmlinkage static int
stub_syscall_67(int sig, const struct old_sigaction* act, struct old_sigaction* oact) {
	typedef int 
		(*stub_func_67)(int sig, const struct old_sigaction* act, struct old_sigaction* oact);
	typedef int
		(*stub_before_func_67)(int sig, const struct old_sigaction* act, struct old_sigaction* oact, int* syscall_rc); 
	typedef int
		(*stub_after_func_67)(int syscall_rc, int sig, const struct old_sigaction* act, struct old_sigaction* oact);

	stub_func_67 orig_syscall_func;
	stub_before_func_67 before_func;
	stub_after_func_67 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[67];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_67)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_67)hdata->orig_syscall;
	after_func = (stub_after_func_67)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(sig, act, oact , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(sig, act, oact) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, sig, act, oact);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 67, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sgetmask' (68). */
asmlinkage static int
stub_syscall_68(void) {
	typedef int 
		(*stub_func_68)(void);
	typedef int
		(*stub_before_func_68)(int* syscall_rc); 
	typedef int
		(*stub_after_func_68)(int syscall_rc);

	stub_func_68 orig_syscall_func;
	stub_before_func_68 before_func;
	stub_after_func_68 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[68];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_68)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_68)hdata->orig_syscall;
	after_func = (stub_after_func_68)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)( &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)() 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval );
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 68, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'ssetmask' (69). */
asmlinkage static int
stub_syscall_69(int newmask) {
	typedef int 
		(*stub_func_69)(int newmask);
	typedef int
		(*stub_before_func_69)(int newmask, int* syscall_rc); 
	typedef int
		(*stub_after_func_69)(int syscall_rc, int newmask);

	stub_func_69 orig_syscall_func;
	stub_before_func_69 before_func;
	stub_after_func_69 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[69];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_69)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_69)hdata->orig_syscall;
	after_func = (stub_after_func_69)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(newmask , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(newmask) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, newmask);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 69, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setreuid16' (70). */
asmlinkage static int
stub_syscall_70(unsigned short ruid, unsigned short euid) {
	typedef int 
		(*stub_func_70)(unsigned short ruid, unsigned short euid);
	typedef int
		(*stub_before_func_70)(unsigned short ruid, unsigned short euid, int* syscall_rc); 
	typedef int
		(*stub_after_func_70)(int syscall_rc, unsigned short ruid, unsigned short euid);

	stub_func_70 orig_syscall_func;
	stub_before_func_70 before_func;
	stub_after_func_70 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[70];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_70)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_70)hdata->orig_syscall;
	after_func = (stub_after_func_70)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(ruid, euid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(ruid, euid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, ruid, euid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 70, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setregid16' (71). */
asmlinkage static int
stub_syscall_71(unsigned short rgid, unsigned short egid) {
	typedef int 
		(*stub_func_71)(unsigned short rgid, unsigned short egid);
	typedef int
		(*stub_before_func_71)(unsigned short rgid, unsigned short egid, int* syscall_rc); 
	typedef int
		(*stub_after_func_71)(int syscall_rc, unsigned short rgid, unsigned short egid);

	stub_func_71 orig_syscall_func;
	stub_before_func_71 before_func;
	stub_after_func_71 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[71];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_71)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_71)hdata->orig_syscall;
	after_func = (stub_after_func_71)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(rgid, egid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(rgid, egid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, rgid, egid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 71, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sigsuspend' (72). */
asmlinkage static int
stub_syscall_72(int history0, int history1, unsigned long mask) {
	typedef int 
		(*stub_func_72)(int history0, int history1, unsigned long mask);
	typedef int
		(*stub_before_func_72)(int history0, int history1, unsigned long mask, int* syscall_rc); 
	typedef int
		(*stub_after_func_72)(int syscall_rc, int history0, int history1, unsigned long mask);

	stub_func_72 orig_syscall_func;
	stub_before_func_72 before_func;
	stub_after_func_72 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[72];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_72)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_72)hdata->orig_syscall;
	after_func = (stub_after_func_72)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(history0, history1, mask , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(history0, history1, mask) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, history0, history1, mask);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 72, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sigpending' (73). */
asmlinkage static int
stub_syscall_73(unsigned long* set) {
	typedef int 
		(*stub_func_73)(unsigned long* set);
	typedef int
		(*stub_before_func_73)(unsigned long* set, int* syscall_rc); 
	typedef int
		(*stub_after_func_73)(int syscall_rc, unsigned long* set);

	stub_func_73 orig_syscall_func;
	stub_before_func_73 before_func;
	stub_after_func_73 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[73];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_73)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_73)hdata->orig_syscall;
	after_func = (stub_after_func_73)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(set , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(set) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, set);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 73, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sethostname' (74). */
asmlinkage static int
stub_syscall_74(char* name, int len) {
	typedef int 
		(*stub_func_74)(char* name, int len);
	typedef int
		(*stub_before_func_74)(char* name, int len, int* syscall_rc); 
	typedef int
		(*stub_after_func_74)(int syscall_rc, char* name, int len);

	stub_func_74 orig_syscall_func;
	stub_before_func_74 before_func;
	stub_after_func_74 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[74];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_74)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_74)hdata->orig_syscall;
	after_func = (stub_after_func_74)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(name, len , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(name, len) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, name, len);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 74, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setrlimit' (75). */
asmlinkage static int
stub_syscall_75(int resource, struct rlimit* rlim) {
	typedef int 
		(*stub_func_75)(int resource, struct rlimit* rlim);
	typedef int
		(*stub_before_func_75)(int resource, struct rlimit* rlim, int* syscall_rc); 
	typedef int
		(*stub_after_func_75)(int syscall_rc, int resource, struct rlimit* rlim);

	stub_func_75 orig_syscall_func;
	stub_before_func_75 before_func;
	stub_after_func_75 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[75];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_75)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_75)hdata->orig_syscall;
	after_func = (stub_after_func_75)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(resource, rlim , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(resource, rlim) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, resource, rlim);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 75, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'old_getrlimit' (76). */
asmlinkage static int
stub_syscall_76(unsigned int resource, struct rlimit* rlim) {
	typedef int 
		(*stub_func_76)(unsigned int resource, struct rlimit* rlim);
	typedef int
		(*stub_before_func_76)(unsigned int resource, struct rlimit* rlim, int* syscall_rc); 
	typedef int
		(*stub_after_func_76)(int syscall_rc, unsigned int resource, struct rlimit* rlim);

	stub_func_76 orig_syscall_func;
	stub_before_func_76 before_func;
	stub_after_func_76 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[76];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_76)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_76)hdata->orig_syscall;
	after_func = (stub_after_func_76)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(resource, rlim , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(resource, rlim) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, resource, rlim);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 76, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getrusage' (77). */
asmlinkage static int
stub_syscall_77(int who, struct rusage* ru) {
	typedef int 
		(*stub_func_77)(int who, struct rusage* ru);
	typedef int
		(*stub_before_func_77)(int who, struct rusage* ru, int* syscall_rc); 
	typedef int
		(*stub_after_func_77)(int syscall_rc, int who, struct rusage* ru);

	stub_func_77 orig_syscall_func;
	stub_before_func_77 before_func;
	stub_after_func_77 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[77];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_77)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_77)hdata->orig_syscall;
	after_func = (stub_after_func_77)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(who, ru , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(who, ru) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, who, ru);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 77, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'gettimeofday' (78). */
asmlinkage static int
stub_syscall_78(struct timeval* tv, struct timezone* tz) {
	typedef int 
		(*stub_func_78)(struct timeval* tv, struct timezone* tz);
	typedef int
		(*stub_before_func_78)(struct timeval* tv, struct timezone* tz, int* syscall_rc); 
	typedef int
		(*stub_after_func_78)(int syscall_rc, struct timeval* tv, struct timezone* tz);

	stub_func_78 orig_syscall_func;
	stub_before_func_78 before_func;
	stub_after_func_78 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[78];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_78)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_78)hdata->orig_syscall;
	after_func = (stub_after_func_78)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(tv, tz , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(tv, tz) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, tv, tz);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 78, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'settimeofday' (79). */
asmlinkage static int
stub_syscall_79(const struct timeval* tv, struct timezone* tz) {
	typedef int 
		(*stub_func_79)(const struct timeval* tv, struct timezone* tz);
	typedef int
		(*stub_before_func_79)(const struct timeval* tv, struct timezone* tz, int* syscall_rc); 
	typedef int
		(*stub_after_func_79)(int syscall_rc, const struct timeval* tv, struct timezone* tz);

	stub_func_79 orig_syscall_func;
	stub_before_func_79 before_func;
	stub_after_func_79 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[79];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_79)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_79)hdata->orig_syscall;
	after_func = (stub_after_func_79)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(tv, tz , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(tv, tz) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, tv, tz);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 79, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getgroups16' (80). */
asmlinkage static int
stub_syscall_80(int gidsetsize, unsigned short* grouplist) {
	typedef int 
		(*stub_func_80)(int gidsetsize, unsigned short* grouplist);
	typedef int
		(*stub_before_func_80)(int gidsetsize, unsigned short* grouplist, int* syscall_rc); 
	typedef int
		(*stub_after_func_80)(int syscall_rc, int gidsetsize, unsigned short* grouplist);

	stub_func_80 orig_syscall_func;
	stub_before_func_80 before_func;
	stub_after_func_80 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[80];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_80)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_80)hdata->orig_syscall;
	after_func = (stub_after_func_80)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(gidsetsize, grouplist , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(gidsetsize, grouplist) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, gidsetsize, grouplist);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 80, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setgroups16' (81). */
asmlinkage static int
stub_syscall_81(int gidsetsize, unsigned short* grouplist) {
	typedef int 
		(*stub_func_81)(int gidsetsize, unsigned short* grouplist);
	typedef int
		(*stub_before_func_81)(int gidsetsize, unsigned short* grouplist, int* syscall_rc); 
	typedef int
		(*stub_after_func_81)(int syscall_rc, int gidsetsize, unsigned short* grouplist);

	stub_func_81 orig_syscall_func;
	stub_before_func_81 before_func;
	stub_after_func_81 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[81];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_81)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_81)hdata->orig_syscall;
	after_func = (stub_after_func_81)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(gidsetsize, grouplist , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(gidsetsize, grouplist) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, gidsetsize, grouplist);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 81, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'old_select' (82). */
asmlinkage static int
stub_syscall_82(struct sel_arg_struct* arg) {
	typedef int 
		(*stub_func_82)(struct sel_arg_struct* arg);
	typedef int
		(*stub_before_func_82)(struct sel_arg_struct* arg, int* syscall_rc); 
	typedef int
		(*stub_after_func_82)(int syscall_rc, struct sel_arg_struct* arg);

	stub_func_82 orig_syscall_func;
	stub_before_func_82 before_func;
	stub_after_func_82 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[82];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_82)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_82)hdata->orig_syscall;
	after_func = (stub_after_func_82)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(arg , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(arg) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, arg);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 82, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'symlink' (83). */
asmlinkage static int
stub_syscall_83(const char* oldpath, const char* newpath) {
	typedef int 
		(*stub_func_83)(const char* oldpath, const char* newpath);
	typedef int
		(*stub_before_func_83)(const char* oldpath, const char* newpath, int* syscall_rc); 
	typedef int
		(*stub_after_func_83)(int syscall_rc, const char* oldpath, const char* newpath);

	stub_func_83 orig_syscall_func;
	stub_before_func_83 before_func;
	stub_after_func_83 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[83];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_83)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_83)hdata->orig_syscall;
	after_func = (stub_after_func_83)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(oldpath, newpath , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(oldpath, newpath) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, oldpath, newpath);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 83, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'lstat' (84). */
asmlinkage static int
stub_syscall_84(char* filename, struct __old_kernel_stat* statbuf) {
	typedef int 
		(*stub_func_84)(char* filename, struct __old_kernel_stat* statbuf);
	typedef int
		(*stub_before_func_84)(char* filename, struct __old_kernel_stat* statbuf, int* syscall_rc); 
	typedef int
		(*stub_after_func_84)(int syscall_rc, char* filename, struct __old_kernel_stat* statbuf);

	stub_func_84 orig_syscall_func;
	stub_before_func_84 before_func;
	stub_after_func_84 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[84];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_84)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_84)hdata->orig_syscall;
	after_func = (stub_after_func_84)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(filename, statbuf , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(filename, statbuf) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, filename, statbuf);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 84, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'readink' (85). */
asmlinkage static int
stub_syscall_85(const char* path, char* buf, int bufsiz) {
	typedef int 
		(*stub_func_85)(const char* path, char* buf, int bufsiz);
	typedef int
		(*stub_before_func_85)(const char* path, char* buf, int bufsiz, int* syscall_rc); 
	typedef int
		(*stub_after_func_85)(int syscall_rc, const char* path, char* buf, int bufsiz);

	stub_func_85 orig_syscall_func;
	stub_before_func_85 before_func;
	stub_after_func_85 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[85];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_85)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_85)hdata->orig_syscall;
	after_func = (stub_after_func_85)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(path, buf, bufsiz , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(path, buf, bufsiz) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, path, buf, bufsiz);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 85, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'uselib' (86). */
asmlinkage static int
stub_syscall_86(const char* library) {
	typedef int 
		(*stub_func_86)(const char* library);
	typedef int
		(*stub_before_func_86)(const char* library, int* syscall_rc); 
	typedef int
		(*stub_after_func_86)(int syscall_rc, const char* library);

	stub_func_86 orig_syscall_func;
	stub_before_func_86 before_func;
	stub_after_func_86 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[86];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_86)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_86)hdata->orig_syscall;
	after_func = (stub_after_func_86)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(library , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(library) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, library);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 86, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'swapon' (87). */
asmlinkage static int
stub_syscall_87(const char* specialfile, int swap_flags) {
	typedef int 
		(*stub_func_87)(const char* specialfile, int swap_flags);
	typedef int
		(*stub_before_func_87)(const char* specialfile, int swap_flags, int* syscall_rc); 
	typedef int
		(*stub_after_func_87)(int syscall_rc, const char* specialfile, int swap_flags);

	stub_func_87 orig_syscall_func;
	stub_before_func_87 before_func;
	stub_after_func_87 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[87];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_87)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_87)hdata->orig_syscall;
	after_func = (stub_after_func_87)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(specialfile, swap_flags , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(specialfile, swap_flags) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, specialfile, swap_flags);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 87, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'reboot' (88). */
asmlinkage static int
stub_syscall_88(int magic1, int magic2, unsigned int cmd, void* arg) {
	typedef int 
		(*stub_func_88)(int magic1, int magic2, unsigned int cmd, void* arg);
	typedef int
		(*stub_before_func_88)(int magic1, int magic2, unsigned int cmd, void* arg, int* syscall_rc); 
	typedef int
		(*stub_after_func_88)(int syscall_rc, int magic1, int magic2, unsigned int cmd, void* arg);

	stub_func_88 orig_syscall_func;
	stub_before_func_88 before_func;
	stub_after_func_88 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[88];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_88)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_88)hdata->orig_syscall;
	after_func = (stub_after_func_88)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(magic1, magic2, cmd, arg , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(magic1, magic2, cmd, arg) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, magic1, magic2, cmd, arg);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 88, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'old_readdir' (89). */
asmlinkage static int
stub_syscall_89(unsigned int fd, void* dirent, unsigned int count) {
	typedef int 
		(*stub_func_89)(unsigned int fd, void* dirent, unsigned int count);
	typedef int
		(*stub_before_func_89)(unsigned int fd, void* dirent, unsigned int count, int* syscall_rc); 
	typedef int
		(*stub_after_func_89)(int syscall_rc, unsigned int fd, void* dirent, unsigned int count);

	stub_func_89 orig_syscall_func;
	stub_before_func_89 before_func;
	stub_after_func_89 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[89];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_89)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_89)hdata->orig_syscall;
	after_func = (stub_after_func_89)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, dirent, count , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, dirent, count) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, dirent, count);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 89, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'old_mmap' (90). */
asmlinkage static int
stub_syscall_90(struct mmap_arg_struct* arg) {
	typedef int 
		(*stub_func_90)(struct mmap_arg_struct* arg);
	typedef int
		(*stub_before_func_90)(struct mmap_arg_struct* arg, int* syscall_rc); 
	typedef int
		(*stub_after_func_90)(int syscall_rc, struct mmap_arg_struct* arg);

	stub_func_90 orig_syscall_func;
	stub_before_func_90 before_func;
	stub_after_func_90 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[90];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_90)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_90)hdata->orig_syscall;
	after_func = (stub_after_func_90)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(arg , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(arg) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, arg);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 90, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'munmap' (91). */
asmlinkage static int
stub_syscall_91(unsigned long addr, size_t len) {
	typedef int 
		(*stub_func_91)(unsigned long addr, size_t len);
	typedef int
		(*stub_before_func_91)(unsigned long addr, size_t len, int* syscall_rc); 
	typedef int
		(*stub_after_func_91)(int syscall_rc, unsigned long addr, size_t len);

	stub_func_91 orig_syscall_func;
	stub_before_func_91 before_func;
	stub_after_func_91 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[91];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_91)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_91)hdata->orig_syscall;
	after_func = (stub_after_func_91)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(addr, len , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(addr, len) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, addr, len);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 91, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'truncate' (92). */
asmlinkage static int
stub_syscall_92(const char* path, unsigned long length) {
	typedef int 
		(*stub_func_92)(const char* path, unsigned long length);
	typedef int
		(*stub_before_func_92)(const char* path, unsigned long length, int* syscall_rc); 
	typedef int
		(*stub_after_func_92)(int syscall_rc, const char* path, unsigned long length);

	stub_func_92 orig_syscall_func;
	stub_before_func_92 before_func;
	stub_after_func_92 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[92];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_92)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_92)hdata->orig_syscall;
	after_func = (stub_after_func_92)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(path, length , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(path, length) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, path, length);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 92, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'ftruncate' (93). */
asmlinkage static int
stub_syscall_93(unsigned int fd, unsigned long length) {
	typedef int 
		(*stub_func_93)(unsigned int fd, unsigned long length);
	typedef int
		(*stub_before_func_93)(unsigned int fd, unsigned long length, int* syscall_rc); 
	typedef int
		(*stub_after_func_93)(int syscall_rc, unsigned int fd, unsigned long length);

	stub_func_93 orig_syscall_func;
	stub_before_func_93 before_func;
	stub_after_func_93 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[93];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_93)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_93)hdata->orig_syscall;
	after_func = (stub_after_func_93)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, length , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, length) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, length);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 93, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'fchmod' (94). */
asmlinkage static int
stub_syscall_94(unsigned int fd, mode_t mode) {
	typedef int 
		(*stub_func_94)(unsigned int fd, mode_t mode);
	typedef int
		(*stub_before_func_94)(unsigned int fd, mode_t mode, int* syscall_rc); 
	typedef int
		(*stub_after_func_94)(int syscall_rc, unsigned int fd, mode_t mode);

	stub_func_94 orig_syscall_func;
	stub_before_func_94 before_func;
	stub_after_func_94 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[94];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_94)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_94)hdata->orig_syscall;
	after_func = (stub_after_func_94)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, mode , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, mode) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, mode);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 94, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'fchown16:' (95). */
asmlinkage static int
stub_syscall_95(unsigned int fd, unsigned short user, unsigned short group) {
	typedef int 
		(*stub_func_95)(unsigned int fd, unsigned short user, unsigned short group);
	typedef int
		(*stub_before_func_95)(unsigned int fd, unsigned short user, unsigned short group, int* syscall_rc); 
	typedef int
		(*stub_after_func_95)(int syscall_rc, unsigned int fd, unsigned short user, unsigned short group);

	stub_func_95 orig_syscall_func;
	stub_before_func_95 before_func;
	stub_after_func_95 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[95];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_95)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_95)hdata->orig_syscall;
	after_func = (stub_after_func_95)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, user, group , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, user, group) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, user, group);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 95, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getpriority' (96). */
asmlinkage static int
stub_syscall_96(int which, int who) {
	typedef int 
		(*stub_func_96)(int which, int who);
	typedef int
		(*stub_before_func_96)(int which, int who, int* syscall_rc); 
	typedef int
		(*stub_after_func_96)(int syscall_rc, int which, int who);

	stub_func_96 orig_syscall_func;
	stub_before_func_96 before_func;
	stub_after_func_96 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[96];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_96)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_96)hdata->orig_syscall;
	after_func = (stub_after_func_96)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(which, who , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(which, who) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, which, who);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 96, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setpriority' (97). */
asmlinkage static int
stub_syscall_97(int which, int who, int pro) {
	typedef int 
		(*stub_func_97)(int which, int who, int pro);
	typedef int
		(*stub_before_func_97)(int which, int who, int pro, int* syscall_rc); 
	typedef int
		(*stub_after_func_97)(int syscall_rc, int which, int who, int pro);

	stub_func_97 orig_syscall_func;
	stub_before_func_97 before_func;
	stub_after_func_97 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[97];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_97)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_97)hdata->orig_syscall;
	after_func = (stub_after_func_97)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(which, who, pro , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(which, who, pro) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, which, who, pro);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 97, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'statfs' (99). */
asmlinkage static int
stub_syscall_99(const char* path, struct statfs* buf) {
	typedef int 
		(*stub_func_99)(const char* path, struct statfs* buf);
	typedef int
		(*stub_before_func_99)(const char* path, struct statfs* buf, int* syscall_rc); 
	typedef int
		(*stub_after_func_99)(int syscall_rc, const char* path, struct statfs* buf);

	stub_func_99 orig_syscall_func;
	stub_before_func_99 before_func;
	stub_after_func_99 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[99];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_99)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_99)hdata->orig_syscall;
	after_func = (stub_after_func_99)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(path, buf , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(path, buf) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, path, buf);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 99, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'fstatfs' (100). */
asmlinkage static int
stub_syscall_100(unsigned int fd, struct statfs* buf) {
	typedef int 
		(*stub_func_100)(unsigned int fd, struct statfs* buf);
	typedef int
		(*stub_before_func_100)(unsigned int fd, struct statfs* buf, int* syscall_rc); 
	typedef int
		(*stub_after_func_100)(int syscall_rc, unsigned int fd, struct statfs* buf);

	stub_func_100 orig_syscall_func;
	stub_before_func_100 before_func;
	stub_after_func_100 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[100];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_100)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_100)hdata->orig_syscall;
	after_func = (stub_after_func_100)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, buf , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, buf) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, buf);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 100, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'ioperm' (101). */
asmlinkage static int
stub_syscall_101(unsigned long from, unsigned long num, int on) {
	typedef int 
		(*stub_func_101)(unsigned long from, unsigned long num, int on);
	typedef int
		(*stub_before_func_101)(unsigned long from, unsigned long num, int on, int* syscall_rc); 
	typedef int
		(*stub_after_func_101)(int syscall_rc, unsigned long from, unsigned long num, int on);

	stub_func_101 orig_syscall_func;
	stub_before_func_101 before_func;
	stub_after_func_101 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[101];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_101)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_101)hdata->orig_syscall;
	after_func = (stub_after_func_101)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(from, num, on , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(from, num, on) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, from, num, on);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 101, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'syslog' (103). */
asmlinkage static int
stub_syscall_103(int type, char* buf, int len) {
	typedef int 
		(*stub_func_103)(int type, char* buf, int len);
	typedef int
		(*stub_before_func_103)(int type, char* buf, int len, int* syscall_rc); 
	typedef int
		(*stub_after_func_103)(int syscall_rc, int type, char* buf, int len);

	stub_func_103 orig_syscall_func;
	stub_before_func_103 before_func;
	stub_after_func_103 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[103];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_103)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_103)hdata->orig_syscall;
	after_func = (stub_after_func_103)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(type, buf, len , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(type, buf, len) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, type, buf, len);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 103, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setitimer' (104). */
asmlinkage static int
stub_syscall_104(int which, struct itimerval* value, struct itimerval* ovalue) {
	typedef int 
		(*stub_func_104)(int which, struct itimerval* value, struct itimerval* ovalue);
	typedef int
		(*stub_before_func_104)(int which, struct itimerval* value, struct itimerval* ovalue, int* syscall_rc); 
	typedef int
		(*stub_after_func_104)(int syscall_rc, int which, struct itimerval* value, struct itimerval* ovalue);

	stub_func_104 orig_syscall_func;
	stub_before_func_104 before_func;
	stub_after_func_104 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[104];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_104)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_104)hdata->orig_syscall;
	after_func = (stub_after_func_104)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(which, value, ovalue , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(which, value, ovalue) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, which, value, ovalue);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 104, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getitimer' (105). */
asmlinkage static int
stub_syscall_105(int which, struct itimerval* value) {
	typedef int 
		(*stub_func_105)(int which, struct itimerval* value);
	typedef int
		(*stub_before_func_105)(int which, struct itimerval* value, int* syscall_rc); 
	typedef int
		(*stub_after_func_105)(int syscall_rc, int which, struct itimerval* value);

	stub_func_105 orig_syscall_func;
	stub_before_func_105 before_func;
	stub_after_func_105 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[105];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_105)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_105)hdata->orig_syscall;
	after_func = (stub_after_func_105)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(which, value , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(which, value) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, which, value);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 105, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'newstat' (106). */
asmlinkage static int
stub_syscall_106(char* filename, struct stat* statbuf) {
	typedef int 
		(*stub_func_106)(char* filename, struct stat* statbuf);
	typedef int
		(*stub_before_func_106)(char* filename, struct stat* statbuf, int* syscall_rc); 
	typedef int
		(*stub_after_func_106)(int syscall_rc, char* filename, struct stat* statbuf);

	stub_func_106 orig_syscall_func;
	stub_before_func_106 before_func;
	stub_after_func_106 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[106];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_106)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_106)hdata->orig_syscall;
	after_func = (stub_after_func_106)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(filename, statbuf , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(filename, statbuf) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, filename, statbuf);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 106, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'newlstat' (107). */
asmlinkage static int
stub_syscall_107(char* filename, struct stat* statbuf) {
	typedef int 
		(*stub_func_107)(char* filename, struct stat* statbuf);
	typedef int
		(*stub_before_func_107)(char* filename, struct stat* statbuf, int* syscall_rc); 
	typedef int
		(*stub_after_func_107)(int syscall_rc, char* filename, struct stat* statbuf);

	stub_func_107 orig_syscall_func;
	stub_before_func_107 before_func;
	stub_after_func_107 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[107];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_107)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_107)hdata->orig_syscall;
	after_func = (stub_after_func_107)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(filename, statbuf , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(filename, statbuf) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, filename, statbuf);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 107, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'newfstat' (108). */
asmlinkage static int
stub_syscall_108(unsigned int fd, struct stat* statbuf) {
	typedef int 
		(*stub_func_108)(unsigned int fd, struct stat* statbuf);
	typedef int
		(*stub_before_func_108)(unsigned int fd, struct stat* statbuf, int* syscall_rc); 
	typedef int
		(*stub_after_func_108)(int syscall_rc, unsigned int fd, struct stat* statbuf);

	stub_func_108 orig_syscall_func;
	stub_before_func_108 before_func;
	stub_after_func_108 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[108];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_108)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_108)hdata->orig_syscall;
	after_func = (stub_after_func_108)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, statbuf , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, statbuf) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, statbuf);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 108, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'uname' (109). */
asmlinkage static int
stub_syscall_109(struct old_utsname* name) {
	typedef int 
		(*stub_func_109)(struct old_utsname* name);
	typedef int
		(*stub_before_func_109)(struct old_utsname* name, int* syscall_rc); 
	typedef int
		(*stub_after_func_109)(int syscall_rc, struct old_utsname* name);

	stub_func_109 orig_syscall_func;
	stub_before_func_109 before_func;
	stub_after_func_109 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[109];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_109)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_109)hdata->orig_syscall;
	after_func = (stub_after_func_109)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(name , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(name) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, name);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 109, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'iopl' (110). */
asmlinkage static int
stub_syscall_110(unsigned long unused) {
	typedef int 
		(*stub_func_110)(unsigned long unused);
	typedef int
		(*stub_before_func_110)(unsigned long unused, int* syscall_rc); 
	typedef int
		(*stub_after_func_110)(int syscall_rc, unsigned long unused);

	stub_func_110 orig_syscall_func;
	stub_before_func_110 before_func;
	stub_after_func_110 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[110];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_110)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_110)hdata->orig_syscall;
	after_func = (stub_after_func_110)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(unused , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(unused) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, unused);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 110, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'vhangup' (111). */
asmlinkage static int
stub_syscall_111(void) {
	typedef int 
		(*stub_func_111)(void);
	typedef int
		(*stub_before_func_111)(int* syscall_rc); 
	typedef int
		(*stub_after_func_111)(int syscall_rc);

	stub_func_111 orig_syscall_func;
	stub_before_func_111 before_func;
	stub_after_func_111 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[111];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_111)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_111)hdata->orig_syscall;
	after_func = (stub_after_func_111)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)( &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)() 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval );
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 111, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'wait4' (114). */
asmlinkage static int
stub_syscall_114(pid_t pid, unsigned int* stat_addr, int options, struct rusage* ru) {
	typedef int 
		(*stub_func_114)(pid_t pid, unsigned int* stat_addr, int options, struct rusage* ru);
	typedef int
		(*stub_before_func_114)(pid_t pid, unsigned int* stat_addr, int options, struct rusage* ru, int* syscall_rc); 
	typedef int
		(*stub_after_func_114)(int syscall_rc, pid_t pid, unsigned int* stat_addr, int options, struct rusage* ru);

	stub_func_114 orig_syscall_func;
	stub_before_func_114 before_func;
	stub_after_func_114 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[114];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_114)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_114)hdata->orig_syscall;
	after_func = (stub_after_func_114)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pid, stat_addr, options, ru , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pid, stat_addr, options, ru) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pid, stat_addr, options, ru);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 114, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'swapoff' (115). */
asmlinkage static int
stub_syscall_115(const char* specialfile) {
	typedef int 
		(*stub_func_115)(const char* specialfile);
	typedef int
		(*stub_before_func_115)(const char* specialfile, int* syscall_rc); 
	typedef int
		(*stub_after_func_115)(int syscall_rc, const char* specialfile);

	stub_func_115 orig_syscall_func;
	stub_before_func_115 before_func;
	stub_after_func_115 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[115];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_115)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_115)hdata->orig_syscall;
	after_func = (stub_after_func_115)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(specialfile , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(specialfile) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, specialfile);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 115, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sysinfo' (116). */
asmlinkage static int
stub_syscall_116(struct sysinfo* info) {
	typedef int 
		(*stub_func_116)(struct sysinfo* info);
	typedef int
		(*stub_before_func_116)(struct sysinfo* info, int* syscall_rc); 
	typedef int
		(*stub_after_func_116)(int syscall_rc, struct sysinfo* info);

	stub_func_116 orig_syscall_func;
	stub_before_func_116 before_func;
	stub_after_func_116 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[116];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_116)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_116)hdata->orig_syscall;
	after_func = (stub_after_func_116)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(info , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(info) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, info);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 116, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'fsync' (118). */
asmlinkage static int
stub_syscall_118(unsigned int fd) {
	typedef int 
		(*stub_func_118)(unsigned int fd);
	typedef int
		(*stub_before_func_118)(unsigned int fd, int* syscall_rc); 
	typedef int
		(*stub_after_func_118)(int syscall_rc, unsigned int fd);

	stub_func_118 orig_syscall_func;
	stub_before_func_118 before_func;
	stub_after_func_118 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[118];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_118)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_118)hdata->orig_syscall;
	after_func = (stub_after_func_118)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 118, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setdomainname' (121). */
asmlinkage static int
stub_syscall_121(char* name, size_t len) {
	typedef int 
		(*stub_func_121)(char* name, size_t len);
	typedef int
		(*stub_before_func_121)(char* name, size_t len, int* syscall_rc); 
	typedef int
		(*stub_after_func_121)(int syscall_rc, char* name, size_t len);

	stub_func_121 orig_syscall_func;
	stub_before_func_121 before_func;
	stub_after_func_121 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[121];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_121)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_121)hdata->orig_syscall;
	after_func = (stub_after_func_121)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(name, len , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(name, len) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, name, len);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 121, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'newuname' (122). */
asmlinkage static int
stub_syscall_122(struct new_utsname* name) {
	typedef int 
		(*stub_func_122)(struct new_utsname* name);
	typedef int
		(*stub_before_func_122)(struct new_utsname* name, int* syscall_rc); 
	typedef int
		(*stub_after_func_122)(int syscall_rc, struct new_utsname* name);

	stub_func_122 orig_syscall_func;
	stub_before_func_122 before_func;
	stub_after_func_122 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[122];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_122)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_122)hdata->orig_syscall;
	after_func = (stub_after_func_122)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(name , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(name) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, name);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 122, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'modify_ldt' (123). */
asmlinkage static int
stub_syscall_123(int func, void* ptr, unsigned long bytecount) {
	typedef int 
		(*stub_func_123)(int func, void* ptr, unsigned long bytecount);
	typedef int
		(*stub_before_func_123)(int func, void* ptr, unsigned long bytecount, int* syscall_rc); 
	typedef int
		(*stub_after_func_123)(int syscall_rc, int func, void* ptr, unsigned long bytecount);

	stub_func_123 orig_syscall_func;
	stub_before_func_123 before_func;
	stub_after_func_123 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[123];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_123)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_123)hdata->orig_syscall;
	after_func = (stub_after_func_123)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(func, ptr, bytecount , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(func, ptr, bytecount) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, func, ptr, bytecount);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 123, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'adjtimex' (124). */
asmlinkage static int
stub_syscall_124(void* txc_p) {
	typedef int 
		(*stub_func_124)(void* txc_p);
	typedef int
		(*stub_before_func_124)(void* txc_p, int* syscall_rc); 
	typedef int
		(*stub_after_func_124)(int syscall_rc, void* txc_p);

	stub_func_124 orig_syscall_func;
	stub_before_func_124 before_func;
	stub_after_func_124 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[124];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_124)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_124)hdata->orig_syscall;
	after_func = (stub_after_func_124)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(txc_p , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(txc_p) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, txc_p);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 124, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'mprotect' (125). */
asmlinkage static int
stub_syscall_125(unsigned long start, size_t len, unsigned long prot) {
	typedef int 
		(*stub_func_125)(unsigned long start, size_t len, unsigned long prot);
	typedef int
		(*stub_before_func_125)(unsigned long start, size_t len, unsigned long prot, int* syscall_rc); 
	typedef int
		(*stub_after_func_125)(int syscall_rc, unsigned long start, size_t len, unsigned long prot);

	stub_func_125 orig_syscall_func;
	stub_before_func_125 before_func;
	stub_after_func_125 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[125];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_125)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_125)hdata->orig_syscall;
	after_func = (stub_after_func_125)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(start, len, prot , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(start, len, prot) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, start, len, prot);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 125, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sigprocmask' (126). */
asmlinkage static int
stub_syscall_126(int how, old_sigset_t set, old_sigset_t oset) {
	typedef int 
		(*stub_func_126)(int how, old_sigset_t set, old_sigset_t oset);
	typedef int
		(*stub_before_func_126)(int how, old_sigset_t set, old_sigset_t oset, int* syscall_rc); 
	typedef int
		(*stub_after_func_126)(int syscall_rc, int how, old_sigset_t set, old_sigset_t oset);

	stub_func_126 orig_syscall_func;
	stub_before_func_126 before_func;
	stub_after_func_126 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[126];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_126)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_126)hdata->orig_syscall;
	after_func = (stub_after_func_126)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(how, set, oset , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(how, set, oset) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, how, set, oset);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 126, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'create_module' (127). */
asmlinkage static int
stub_syscall_127(const char* name_user, size_t size) {
	typedef int 
		(*stub_func_127)(const char* name_user, size_t size);
	typedef int
		(*stub_before_func_127)(const char* name_user, size_t size, int* syscall_rc); 
	typedef int
		(*stub_after_func_127)(int syscall_rc, const char* name_user, size_t size);

	stub_func_127 orig_syscall_func;
	stub_before_func_127 before_func;
	stub_after_func_127 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[127];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_127)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_127)hdata->orig_syscall;
	after_func = (stub_after_func_127)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(name_user, size , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(name_user, size) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, name_user, size);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 127, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'init_module' (128). */
asmlinkage static int
stub_syscall_128(const char* name_user, void* mod_user) {
	typedef int 
		(*stub_func_128)(const char* name_user, void* mod_user);
	typedef int
		(*stub_before_func_128)(const char* name_user, void* mod_user, int* syscall_rc); 
	typedef int
		(*stub_after_func_128)(int syscall_rc, const char* name_user, void* mod_user);

	stub_func_128 orig_syscall_func;
	stub_before_func_128 before_func;
	stub_after_func_128 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[128];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_128)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_128)hdata->orig_syscall;
	after_func = (stub_after_func_128)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(name_user, mod_user , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(name_user, mod_user) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, name_user, mod_user);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 128, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'delete_module' (129). */
asmlinkage static int
stub_syscall_129(const char* name_user) {
	typedef int 
		(*stub_func_129)(const char* name_user);
	typedef int
		(*stub_before_func_129)(const char* name_user, int* syscall_rc); 
	typedef int
		(*stub_after_func_129)(int syscall_rc, const char* name_user);

	stub_func_129 orig_syscall_func;
	stub_before_func_129 before_func;
	stub_after_func_129 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[129];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_129)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_129)hdata->orig_syscall;
	after_func = (stub_after_func_129)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(name_user , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(name_user) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, name_user);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 129, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'get_kernel_syms' (130). */
asmlinkage static int
stub_syscall_130(struct kernel_sym* table) {
	typedef int 
		(*stub_func_130)(struct kernel_sym* table);
	typedef int
		(*stub_before_func_130)(struct kernel_sym* table, int* syscall_rc); 
	typedef int
		(*stub_after_func_130)(int syscall_rc, struct kernel_sym* table);

	stub_func_130 orig_syscall_func;
	stub_before_func_130 before_func;
	stub_after_func_130 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[130];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_130)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_130)hdata->orig_syscall;
	after_func = (stub_after_func_130)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(table , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(table) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, table);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 130, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'quotactl' (131). */
asmlinkage static int
stub_syscall_131(unsigned int cmd, const char* special, gid_t id, void* addr) {
	typedef int 
		(*stub_func_131)(unsigned int cmd, const char* special, gid_t id, void* addr);
	typedef int
		(*stub_before_func_131)(unsigned int cmd, const char* special, gid_t id, void* addr, int* syscall_rc); 
	typedef int
		(*stub_after_func_131)(int syscall_rc, unsigned int cmd, const char* special, gid_t id, void* addr);

	stub_func_131 orig_syscall_func;
	stub_before_func_131 before_func;
	stub_after_func_131 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[131];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_131)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_131)hdata->orig_syscall;
	after_func = (stub_after_func_131)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(cmd, special, id, addr , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(cmd, special, id, addr) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, cmd, special, id, addr);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 131, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getpgid' (132). */
asmlinkage static int
stub_syscall_132(pid_t pid) {
	typedef int 
		(*stub_func_132)(pid_t pid);
	typedef int
		(*stub_before_func_132)(pid_t pid, int* syscall_rc); 
	typedef int
		(*stub_after_func_132)(int syscall_rc, pid_t pid);

	stub_func_132 orig_syscall_func;
	stub_before_func_132 before_func;
	stub_after_func_132 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[132];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_132)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_132)hdata->orig_syscall;
	after_func = (stub_after_func_132)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 132, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'fchdir' (133). */
asmlinkage static int
stub_syscall_133(int fd) {
	typedef int 
		(*stub_func_133)(int fd);
	typedef int
		(*stub_before_func_133)(int fd, int* syscall_rc); 
	typedef int
		(*stub_after_func_133)(int syscall_rc, int fd);

	stub_func_133 orig_syscall_func;
	stub_before_func_133 before_func;
	stub_after_func_133 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[133];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_133)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_133)hdata->orig_syscall;
	after_func = (stub_after_func_133)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 133, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sysfs' (135). */
asmlinkage static int
stub_syscall_135(int option, unsigned long arg1, unsigned long arg2) {
	typedef int 
		(*stub_func_135)(int option, unsigned long arg1, unsigned long arg2);
	typedef int
		(*stub_before_func_135)(int option, unsigned long arg1, unsigned long arg2, int* syscall_rc); 
	typedef int
		(*stub_after_func_135)(int syscall_rc, int option, unsigned long arg1, unsigned long arg2);

	stub_func_135 orig_syscall_func;
	stub_before_func_135 before_func;
	stub_after_func_135 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[135];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_135)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_135)hdata->orig_syscall;
	after_func = (stub_after_func_135)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(option, arg1, arg2 , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(option, arg1, arg2) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, option, arg1, arg2);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 135, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'personality' (136). */
asmlinkage static int
stub_syscall_136(unsigned long persona) {
	typedef int 
		(*stub_func_136)(unsigned long persona);
	typedef int
		(*stub_before_func_136)(unsigned long persona, int* syscall_rc); 
	typedef int
		(*stub_after_func_136)(int syscall_rc, unsigned long persona);

	stub_func_136 orig_syscall_func;
	stub_before_func_136 before_func;
	stub_after_func_136 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[136];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_136)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_136)hdata->orig_syscall;
	after_func = (stub_after_func_136)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(persona , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(persona) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, persona);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 136, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setfsuid16' (138). */
asmlinkage static int
stub_syscall_138(old_uid_t uid) {
	typedef int 
		(*stub_func_138)(old_uid_t uid);
	typedef int
		(*stub_before_func_138)(old_uid_t uid, int* syscall_rc); 
	typedef int
		(*stub_after_func_138)(int syscall_rc, old_uid_t uid);

	stub_func_138 orig_syscall_func;
	stub_before_func_138 before_func;
	stub_after_func_138 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[138];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_138)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_138)hdata->orig_syscall;
	after_func = (stub_after_func_138)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(uid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(uid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, uid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 138, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setfsgid16' (139). */
asmlinkage static int
stub_syscall_139(old_gid_t gid) {
	typedef int 
		(*stub_func_139)(old_gid_t gid);
	typedef int
		(*stub_before_func_139)(old_gid_t gid, int* syscall_rc); 
	typedef int
		(*stub_after_func_139)(int syscall_rc, old_gid_t gid);

	stub_func_139 orig_syscall_func;
	stub_before_func_139 before_func;
	stub_after_func_139 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[139];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_139)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_139)hdata->orig_syscall;
	after_func = (stub_after_func_139)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(gid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(gid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, gid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 139, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'llseek' (140). */
asmlinkage static int
stub_syscall_140(unsigned int fd, unsigned long offset_high, unsigned long offset_low, loff_t* result, unsigned int origin) {
	typedef int 
		(*stub_func_140)(unsigned int fd, unsigned long offset_high, unsigned long offset_low, loff_t* result, unsigned int origin);
	typedef int
		(*stub_before_func_140)(unsigned int fd, unsigned long offset_high, unsigned long offset_low, loff_t* result, unsigned int origin, int* syscall_rc); 
	typedef int
		(*stub_after_func_140)(int syscall_rc, unsigned int fd, unsigned long offset_high, unsigned long offset_low, loff_t* result, unsigned int origin);

	stub_func_140 orig_syscall_func;
	stub_before_func_140 before_func;
	stub_after_func_140 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[140];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_140)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_140)hdata->orig_syscall;
	after_func = (stub_after_func_140)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, offset_high, offset_low, result, origin , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, offset_high, offset_low, result, origin) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, offset_high, offset_low, result, origin);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 140, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getdents' (141). */
asmlinkage static int
stub_syscall_141(unsigned int fd, void* dirent, unsigned int count) {
	typedef int 
		(*stub_func_141)(unsigned int fd, void* dirent, unsigned int count);
	typedef int
		(*stub_before_func_141)(unsigned int fd, void* dirent, unsigned int count, int* syscall_rc); 
	typedef int
		(*stub_after_func_141)(int syscall_rc, unsigned int fd, void* dirent, unsigned int count);

	stub_func_141 orig_syscall_func;
	stub_before_func_141 before_func;
	stub_after_func_141 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[141];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_141)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_141)hdata->orig_syscall;
	after_func = (stub_after_func_141)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, dirent, count , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, dirent, count) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, dirent, count);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 141, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'select' (142). */
asmlinkage static int
stub_syscall_142(int n, void* inp, void* outp, void* exp, struct timeval* tvp) {
	typedef int 
		(*stub_func_142)(int n, void* inp, void* outp, void* exp, struct timeval* tvp);
	typedef int
		(*stub_before_func_142)(int n, void* inp, void* outp, void* exp, struct timeval* tvp, int* syscall_rc); 
	typedef int
		(*stub_after_func_142)(int syscall_rc, int n, void* inp, void* outp, void* exp, struct timeval* tvp);

	stub_func_142 orig_syscall_func;
	stub_before_func_142 before_func;
	stub_after_func_142 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[142];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_142)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_142)hdata->orig_syscall;
	after_func = (stub_after_func_142)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(n, inp, outp, exp, tvp , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(n, inp, outp, exp, tvp) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, n, inp, outp, exp, tvp);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 142, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'flock' (143). */
asmlinkage static int
stub_syscall_143(int fd, int operation) {
	typedef int 
		(*stub_func_143)(int fd, int operation);
	typedef int
		(*stub_before_func_143)(int fd, int operation, int* syscall_rc); 
	typedef int
		(*stub_after_func_143)(int syscall_rc, int fd, int operation);

	stub_func_143 orig_syscall_func;
	stub_before_func_143 before_func;
	stub_after_func_143 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[143];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_143)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_143)hdata->orig_syscall;
	after_func = (stub_after_func_143)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, operation , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, operation) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, operation);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 143, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'msync' (144). */
asmlinkage static int
stub_syscall_144(void* start, int length, int flags) {
	typedef int 
		(*stub_func_144)(void* start, int length, int flags);
	typedef int
		(*stub_before_func_144)(void* start, int length, int flags, int* syscall_rc); 
	typedef int
		(*stub_after_func_144)(int syscall_rc, void* start, int length, int flags);

	stub_func_144 orig_syscall_func;
	stub_before_func_144 before_func;
	stub_after_func_144 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[144];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_144)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_144)hdata->orig_syscall;
	after_func = (stub_after_func_144)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(start, length, flags , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(start, length, flags) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, start, length, flags);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 144, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'readv' (145). */
asmlinkage static int
stub_syscall_145(int fd, struct iovec* vector, int count) {
	typedef int 
		(*stub_func_145)(int fd, struct iovec* vector, int count);
	typedef int
		(*stub_before_func_145)(int fd, struct iovec* vector, int count, int* syscall_rc); 
	typedef int
		(*stub_after_func_145)(int syscall_rc, int fd, struct iovec* vector, int count);

	stub_func_145 orig_syscall_func;
	stub_before_func_145 before_func;
	stub_after_func_145 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[145];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_145)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_145)hdata->orig_syscall;
	after_func = (stub_after_func_145)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, vector, count , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, vector, count) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, vector, count);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 145, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'writev' (146). */
asmlinkage static int
stub_syscall_146(int fd, struct iovec* vector, int count) {
	typedef int 
		(*stub_func_146)(int fd, struct iovec* vector, int count);
	typedef int
		(*stub_before_func_146)(int fd, struct iovec* vector, int count, int* syscall_rc); 
	typedef int
		(*stub_after_func_146)(int syscall_rc, int fd, struct iovec* vector, int count);

	stub_func_146 orig_syscall_func;
	stub_before_func_146 before_func;
	stub_after_func_146 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[146];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_146)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_146)hdata->orig_syscall;
	after_func = (stub_after_func_146)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, vector, count , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, vector, count) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, vector, count);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 146, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getsid' (147). */
asmlinkage static int
stub_syscall_147(pid_t pid) {
	typedef int 
		(*stub_func_147)(pid_t pid);
	typedef int
		(*stub_before_func_147)(pid_t pid, int* syscall_rc); 
	typedef int
		(*stub_after_func_147)(int syscall_rc, pid_t pid);

	stub_func_147 orig_syscall_func;
	stub_before_func_147 before_func;
	stub_after_func_147 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[147];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_147)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_147)hdata->orig_syscall;
	after_func = (stub_after_func_147)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 147, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'fdatasync' (148). */
asmlinkage static int
stub_syscall_148(int fd) {
	typedef int 
		(*stub_func_148)(int fd);
	typedef int
		(*stub_before_func_148)(int fd, int* syscall_rc); 
	typedef int
		(*stub_after_func_148)(int syscall_rc, int fd);

	stub_func_148 orig_syscall_func;
	stub_before_func_148 before_func;
	stub_after_func_148 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[148];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_148)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_148)hdata->orig_syscall;
	after_func = (stub_after_func_148)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 148, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sysctl' (149). */
asmlinkage static int
stub_syscall_149(struct __sysctl_args* args) {
	typedef int 
		(*stub_func_149)(struct __sysctl_args* args);
	typedef int
		(*stub_before_func_149)(struct __sysctl_args* args, int* syscall_rc); 
	typedef int
		(*stub_after_func_149)(int syscall_rc, struct __sysctl_args* args);

	stub_func_149 orig_syscall_func;
	stub_before_func_149 before_func;
	stub_after_func_149 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[149];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_149)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_149)hdata->orig_syscall;
	after_func = (stub_after_func_149)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(args , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(args) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, args);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 149, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'mlock' (150). */
asmlinkage static int
stub_syscall_150(unsigned long start, size_t len) {
	typedef int 
		(*stub_func_150)(unsigned long start, size_t len);
	typedef int
		(*stub_before_func_150)(unsigned long start, size_t len, int* syscall_rc); 
	typedef int
		(*stub_after_func_150)(int syscall_rc, unsigned long start, size_t len);

	stub_func_150 orig_syscall_func;
	stub_before_func_150 before_func;
	stub_after_func_150 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[150];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_150)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_150)hdata->orig_syscall;
	after_func = (stub_after_func_150)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(start, len , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(start, len) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, start, len);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 150, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'munlock' (151). */
asmlinkage static int
stub_syscall_151(unsigned long start, size_t len) {
	typedef int 
		(*stub_func_151)(unsigned long start, size_t len);
	typedef int
		(*stub_before_func_151)(unsigned long start, size_t len, int* syscall_rc); 
	typedef int
		(*stub_after_func_151)(int syscall_rc, unsigned long start, size_t len);

	stub_func_151 orig_syscall_func;
	stub_before_func_151 before_func;
	stub_after_func_151 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[151];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_151)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_151)hdata->orig_syscall;
	after_func = (stub_after_func_151)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(start, len , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(start, len) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, start, len);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 151, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'mlockall' (152). */
asmlinkage static int
stub_syscall_152(int flag) {
	typedef int 
		(*stub_func_152)(int flag);
	typedef int
		(*stub_before_func_152)(int flag, int* syscall_rc); 
	typedef int
		(*stub_after_func_152)(int syscall_rc, int flag);

	stub_func_152 orig_syscall_func;
	stub_before_func_152 before_func;
	stub_after_func_152 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[152];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_152)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_152)hdata->orig_syscall;
	after_func = (stub_after_func_152)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(flag , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(flag) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, flag);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 152, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'munlockall' (153). */
asmlinkage static int
stub_syscall_153(void) {
	typedef int 
		(*stub_func_153)(void);
	typedef int
		(*stub_before_func_153)(int* syscall_rc); 
	typedef int
		(*stub_after_func_153)(int syscall_rc);

	stub_func_153 orig_syscall_func;
	stub_before_func_153 before_func;
	stub_after_func_153 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[153];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_153)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_153)hdata->orig_syscall;
	after_func = (stub_after_func_153)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)( &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)() 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval );
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 153, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sched_setparam' (154). */
asmlinkage static int
stub_syscall_154(pid_t pid, struct sched_param* param) {
	typedef int 
		(*stub_func_154)(pid_t pid, struct sched_param* param);
	typedef int
		(*stub_before_func_154)(pid_t pid, struct sched_param* param, int* syscall_rc); 
	typedef int
		(*stub_after_func_154)(int syscall_rc, pid_t pid, struct sched_param* param);

	stub_func_154 orig_syscall_func;
	stub_before_func_154 before_func;
	stub_after_func_154 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[154];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_154)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_154)hdata->orig_syscall;
	after_func = (stub_after_func_154)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pid, param , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pid, param) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pid, param);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 154, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sched_getparam' (155). */
asmlinkage static int
stub_syscall_155(pid_t pid, struct sched_param* param) {
	typedef int 
		(*stub_func_155)(pid_t pid, struct sched_param* param);
	typedef int
		(*stub_before_func_155)(pid_t pid, struct sched_param* param, int* syscall_rc); 
	typedef int
		(*stub_after_func_155)(int syscall_rc, pid_t pid, struct sched_param* param);

	stub_func_155 orig_syscall_func;
	stub_before_func_155 before_func;
	stub_after_func_155 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[155];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_155)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_155)hdata->orig_syscall;
	after_func = (stub_after_func_155)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pid, param , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pid, param) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pid, param);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 155, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sched_setscheduler' (156). */
asmlinkage static int
stub_syscall_156(pid_t pid, int policy, struct sched_param* param) {
	typedef int 
		(*stub_func_156)(pid_t pid, int policy, struct sched_param* param);
	typedef int
		(*stub_before_func_156)(pid_t pid, int policy, struct sched_param* param, int* syscall_rc); 
	typedef int
		(*stub_after_func_156)(int syscall_rc, pid_t pid, int policy, struct sched_param* param);

	stub_func_156 orig_syscall_func;
	stub_before_func_156 before_func;
	stub_after_func_156 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[156];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_156)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_156)hdata->orig_syscall;
	after_func = (stub_after_func_156)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pid, policy, param , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pid, policy, param) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pid, policy, param);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 156, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sched_getscheduler' (157). */
asmlinkage static int
stub_syscall_157(pid_t pid, int policy, struct sched_param* param) {
	typedef int 
		(*stub_func_157)(pid_t pid, int policy, struct sched_param* param);
	typedef int
		(*stub_before_func_157)(pid_t pid, int policy, struct sched_param* param, int* syscall_rc); 
	typedef int
		(*stub_after_func_157)(int syscall_rc, pid_t pid, int policy, struct sched_param* param);

	stub_func_157 orig_syscall_func;
	stub_before_func_157 before_func;
	stub_after_func_157 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[157];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_157)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_157)hdata->orig_syscall;
	after_func = (stub_after_func_157)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pid, policy, param , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pid, policy, param) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pid, policy, param);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 157, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sched_yield' (158). */
asmlinkage static int
stub_syscall_158(void) {
	typedef int 
		(*stub_func_158)(void);
	typedef int
		(*stub_before_func_158)(int* syscall_rc); 
	typedef int
		(*stub_after_func_158)(int syscall_rc);

	stub_func_158 orig_syscall_func;
	stub_before_func_158 before_func;
	stub_after_func_158 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[158];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_158)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_158)hdata->orig_syscall;
	after_func = (stub_after_func_158)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)( &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)() 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval );
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 158, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sched_get_priority_max' (159). */
asmlinkage static int
stub_syscall_159(int policy) {
	typedef int 
		(*stub_func_159)(int policy);
	typedef int
		(*stub_before_func_159)(int policy, int* syscall_rc); 
	typedef int
		(*stub_after_func_159)(int syscall_rc, int policy);

	stub_func_159 orig_syscall_func;
	stub_before_func_159 before_func;
	stub_after_func_159 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[159];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_159)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_159)hdata->orig_syscall;
	after_func = (stub_after_func_159)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(policy , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(policy) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, policy);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 159, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sched_get_priority_min' (160). */
asmlinkage static int
stub_syscall_160(int policy) {
	typedef int 
		(*stub_func_160)(int policy);
	typedef int
		(*stub_before_func_160)(int policy, int* syscall_rc); 
	typedef int
		(*stub_after_func_160)(int syscall_rc, int policy);

	stub_func_160 orig_syscall_func;
	stub_before_func_160 before_func;
	stub_after_func_160 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[160];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_160)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_160)hdata->orig_syscall;
	after_func = (stub_after_func_160)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(policy , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(policy) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, policy);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 160, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sched_rr_get_interval' (161). */
asmlinkage static int
stub_syscall_161(pid_t pid, struct timespec* interval) {
	typedef int 
		(*stub_func_161)(pid_t pid, struct timespec* interval);
	typedef int
		(*stub_before_func_161)(pid_t pid, struct timespec* interval, int* syscall_rc); 
	typedef int
		(*stub_after_func_161)(int syscall_rc, pid_t pid, struct timespec* interval);

	stub_func_161 orig_syscall_func;
	stub_before_func_161 before_func;
	stub_after_func_161 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[161];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_161)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_161)hdata->orig_syscall;
	after_func = (stub_after_func_161)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pid, interval , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pid, interval) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pid, interval);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 161, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'nanosleep' (162). */
asmlinkage static int
stub_syscall_162(struct timespec* rqtp, struct timespec* rmtp) {
	typedef int 
		(*stub_func_162)(struct timespec* rqtp, struct timespec* rmtp);
	typedef int
		(*stub_before_func_162)(struct timespec* rqtp, struct timespec* rmtp, int* syscall_rc); 
	typedef int
		(*stub_after_func_162)(int syscall_rc, struct timespec* rqtp, struct timespec* rmtp);

	stub_func_162 orig_syscall_func;
	stub_before_func_162 before_func;
	stub_after_func_162 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[162];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_162)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_162)hdata->orig_syscall;
	after_func = (stub_after_func_162)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(rqtp, rmtp , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(rqtp, rmtp) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, rqtp, rmtp);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 162, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'mremap' (163). */
asmlinkage static int
stub_syscall_163(unsigned long addr, unsigned long old_len, unsigned long new_len, unsigned long flags, unsigned long new_addr) {
	typedef int 
		(*stub_func_163)(unsigned long addr, unsigned long old_len, unsigned long new_len, unsigned long flags, unsigned long new_addr);
	typedef int
		(*stub_before_func_163)(unsigned long addr, unsigned long old_len, unsigned long new_len, unsigned long flags, unsigned long new_addr, int* syscall_rc); 
	typedef int
		(*stub_after_func_163)(int syscall_rc, unsigned long addr, unsigned long old_len, unsigned long new_len, unsigned long flags, unsigned long new_addr);

	stub_func_163 orig_syscall_func;
	stub_before_func_163 before_func;
	stub_after_func_163 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[163];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_163)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_163)hdata->orig_syscall;
	after_func = (stub_after_func_163)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(addr, old_len, new_len, flags, new_addr , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(addr, old_len, new_len, flags, new_addr) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, addr, old_len, new_len, flags, new_addr);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 163, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setresuid16' (164). */
asmlinkage static int
stub_syscall_164(old_uid_t ruid, old_uid_t euid, old_uid_t suid) {
	typedef int 
		(*stub_func_164)(old_uid_t ruid, old_uid_t euid, old_uid_t suid);
	typedef int
		(*stub_before_func_164)(old_uid_t ruid, old_uid_t euid, old_uid_t suid, int* syscall_rc); 
	typedef int
		(*stub_after_func_164)(int syscall_rc, old_uid_t ruid, old_uid_t euid, old_uid_t suid);

	stub_func_164 orig_syscall_func;
	stub_before_func_164 before_func;
	stub_after_func_164 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[164];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_164)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_164)hdata->orig_syscall;
	after_func = (stub_after_func_164)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(ruid, euid, suid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(ruid, euid, suid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, ruid, euid, suid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 164, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getresuid16' (165). */
asmlinkage static int
stub_syscall_165(old_uid_t* ruid, old_uid_t* euid, old_uid_t* suid) {
	typedef int 
		(*stub_func_165)(old_uid_t* ruid, old_uid_t* euid, old_uid_t* suid);
	typedef int
		(*stub_before_func_165)(old_uid_t* ruid, old_uid_t* euid, old_uid_t* suid, int* syscall_rc); 
	typedef int
		(*stub_after_func_165)(int syscall_rc, old_uid_t* ruid, old_uid_t* euid, old_uid_t* suid);

	stub_func_165 orig_syscall_func;
	stub_before_func_165 before_func;
	stub_after_func_165 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[165];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_165)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_165)hdata->orig_syscall;
	after_func = (stub_after_func_165)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(ruid, euid, suid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(ruid, euid, suid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, ruid, euid, suid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 165, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'query_module' (167). */
asmlinkage static int
stub_syscall_167(const char* name_user, int which, char* buf, size_t bufsize, size_t* ret) {
	typedef int 
		(*stub_func_167)(const char* name_user, int which, char* buf, size_t bufsize, size_t* ret);
	typedef int
		(*stub_before_func_167)(const char* name_user, int which, char* buf, size_t bufsize, size_t* ret, int* syscall_rc); 
	typedef int
		(*stub_after_func_167)(int syscall_rc, const char* name_user, int which, char* buf, size_t bufsize, size_t* ret);

	stub_func_167 orig_syscall_func;
	stub_before_func_167 before_func;
	stub_after_func_167 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[167];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_167)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_167)hdata->orig_syscall;
	after_func = (stub_after_func_167)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(name_user, which, buf, bufsize, ret , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(name_user, which, buf, bufsize, ret) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, name_user, which, buf, bufsize, ret);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 167, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'poll' (168). */
asmlinkage static int
stub_syscall_168(struct pollfd* ufds, unsigned int nfds, long timeout) {
	typedef int 
		(*stub_func_168)(struct pollfd* ufds, unsigned int nfds, long timeout);
	typedef int
		(*stub_before_func_168)(struct pollfd* ufds, unsigned int nfds, long timeout, int* syscall_rc); 
	typedef int
		(*stub_after_func_168)(int syscall_rc, struct pollfd* ufds, unsigned int nfds, long timeout);

	stub_func_168 orig_syscall_func;
	stub_before_func_168 before_func;
	stub_after_func_168 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[168];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_168)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_168)hdata->orig_syscall;
	after_func = (stub_after_func_168)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(ufds, nfds, timeout , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(ufds, nfds, timeout) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, ufds, nfds, timeout);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 168, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'nfsservctl' (169). */
asmlinkage static int
stub_syscall_169(int cmd, void* argp, void* resp) {
	typedef int 
		(*stub_func_169)(int cmd, void* argp, void* resp);
	typedef int
		(*stub_before_func_169)(int cmd, void* argp, void* resp, int* syscall_rc); 
	typedef int
		(*stub_after_func_169)(int syscall_rc, int cmd, void* argp, void* resp);

	stub_func_169 orig_syscall_func;
	stub_before_func_169 before_func;
	stub_after_func_169 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[169];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_169)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_169)hdata->orig_syscall;
	after_func = (stub_after_func_169)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(cmd, argp, resp , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(cmd, argp, resp) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, cmd, argp, resp);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 169, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setresgid16' (170). */
asmlinkage static int
stub_syscall_170(old_gid_t rgid, old_gid_t egid, old_gid_t sgid) {
	typedef int 
		(*stub_func_170)(old_gid_t rgid, old_gid_t egid, old_gid_t sgid);
	typedef int
		(*stub_before_func_170)(old_gid_t rgid, old_gid_t egid, old_gid_t sgid, int* syscall_rc); 
	typedef int
		(*stub_after_func_170)(int syscall_rc, old_gid_t rgid, old_gid_t egid, old_gid_t sgid);

	stub_func_170 orig_syscall_func;
	stub_before_func_170 before_func;
	stub_after_func_170 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[170];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_170)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_170)hdata->orig_syscall;
	after_func = (stub_after_func_170)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(rgid, egid, sgid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(rgid, egid, sgid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, rgid, egid, sgid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 170, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getresgid16' (171). */
asmlinkage static int
stub_syscall_171(old_gid_t* rgid, old_gid_t* egid, old_gid_t* sgid) {
	typedef int 
		(*stub_func_171)(old_gid_t* rgid, old_gid_t* egid, old_gid_t* sgid);
	typedef int
		(*stub_before_func_171)(old_gid_t* rgid, old_gid_t* egid, old_gid_t* sgid, int* syscall_rc); 
	typedef int
		(*stub_after_func_171)(int syscall_rc, old_gid_t* rgid, old_gid_t* egid, old_gid_t* sgid);

	stub_func_171 orig_syscall_func;
	stub_before_func_171 before_func;
	stub_after_func_171 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[171];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_171)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_171)hdata->orig_syscall;
	after_func = (stub_after_func_171)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(rgid, egid, sgid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(rgid, egid, sgid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, rgid, egid, sgid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 171, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'prctl' (172). */
asmlinkage static int
stub_syscall_172(int option, unsigned long arg2, unsigned long arg3, unsigned long arg4, unsigned long arg5) {
	typedef int 
		(*stub_func_172)(int option, unsigned long arg2, unsigned long arg3, unsigned long arg4, unsigned long arg5);
	typedef int
		(*stub_before_func_172)(int option, unsigned long arg2, unsigned long arg3, unsigned long arg4, unsigned long arg5, int* syscall_rc); 
	typedef int
		(*stub_after_func_172)(int syscall_rc, int option, unsigned long arg2, unsigned long arg3, unsigned long arg4, unsigned long arg5);

	stub_func_172 orig_syscall_func;
	stub_before_func_172 before_func;
	stub_after_func_172 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[172];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_172)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_172)hdata->orig_syscall;
	after_func = (stub_after_func_172)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(option, arg2, arg3, arg4, arg5 , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(option, arg2, arg3, arg4, arg5) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, option, arg2, arg3, arg4, arg5);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 172, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'rt_sigaction' (174). */
asmlinkage static int
stub_syscall_174(int sig, void* act, void* oact, size_t sigsetsize) {
	typedef int 
		(*stub_func_174)(int sig, void* act, void* oact, size_t sigsetsize);
	typedef int
		(*stub_before_func_174)(int sig, void* act, void* oact, size_t sigsetsize, int* syscall_rc); 
	typedef int
		(*stub_after_func_174)(int syscall_rc, int sig, void* act, void* oact, size_t sigsetsize);

	stub_func_174 orig_syscall_func;
	stub_before_func_174 before_func;
	stub_after_func_174 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[174];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_174)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_174)hdata->orig_syscall;
	after_func = (stub_after_func_174)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(sig, act, oact, sigsetsize , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(sig, act, oact, sigsetsize) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, sig, act, oact, sigsetsize);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 174, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'rt_sigprocmask' (175). */
asmlinkage static int
stub_syscall_175(int how, void* set, void* oset, size_t sigsetsize) {
	typedef int 
		(*stub_func_175)(int how, void* set, void* oset, size_t sigsetsize);
	typedef int
		(*stub_before_func_175)(int how, void* set, void* oset, size_t sigsetsize, int* syscall_rc); 
	typedef int
		(*stub_after_func_175)(int syscall_rc, int how, void* set, void* oset, size_t sigsetsize);

	stub_func_175 orig_syscall_func;
	stub_before_func_175 before_func;
	stub_after_func_175 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[175];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_175)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_175)hdata->orig_syscall;
	after_func = (stub_after_func_175)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(how, set, oset, sigsetsize , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(how, set, oset, sigsetsize) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, how, set, oset, sigsetsize);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 175, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'rt_sigpending' (176). */
asmlinkage static int
stub_syscall_176(void* set, size_t sigsetsize) {
	typedef int 
		(*stub_func_176)(void* set, size_t sigsetsize);
	typedef int
		(*stub_before_func_176)(void* set, size_t sigsetsize, int* syscall_rc); 
	typedef int
		(*stub_after_func_176)(int syscall_rc, void* set, size_t sigsetsize);

	stub_func_176 orig_syscall_func;
	stub_before_func_176 before_func;
	stub_after_func_176 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[176];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_176)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_176)hdata->orig_syscall;
	after_func = (stub_after_func_176)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(set, sigsetsize , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(set, sigsetsize) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, set, sigsetsize);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 176, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'rt_sigtimedwait' (177). */
asmlinkage static int
stub_syscall_177(void* uthese, void* uinfo, const struct timespec* uts, size_t sigsetsize) {
	typedef int 
		(*stub_func_177)(void* uthese, void* uinfo, const struct timespec* uts, size_t sigsetsize);
	typedef int
		(*stub_before_func_177)(void* uthese, void* uinfo, const struct timespec* uts, size_t sigsetsize, int* syscall_rc); 
	typedef int
		(*stub_after_func_177)(int syscall_rc, void* uthese, void* uinfo, const struct timespec* uts, size_t sigsetsize);

	stub_func_177 orig_syscall_func;
	stub_before_func_177 before_func;
	stub_after_func_177 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[177];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_177)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_177)hdata->orig_syscall;
	after_func = (stub_after_func_177)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(uthese, uinfo, uts, sigsetsize , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(uthese, uinfo, uts, sigsetsize) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, uthese, uinfo, uts, sigsetsize);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 177, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'rt_sigqueueinfo' (178). */
asmlinkage static int
stub_syscall_178(int pid, int sig, void* uinfo) {
	typedef int 
		(*stub_func_178)(int pid, int sig, void* uinfo);
	typedef int
		(*stub_before_func_178)(int pid, int sig, void* uinfo, int* syscall_rc); 
	typedef int
		(*stub_after_func_178)(int syscall_rc, int pid, int sig, void* uinfo);

	stub_func_178 orig_syscall_func;
	stub_before_func_178 before_func;
	stub_after_func_178 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[178];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_178)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_178)hdata->orig_syscall;
	after_func = (stub_after_func_178)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pid, sig, uinfo , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pid, sig, uinfo) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pid, sig, uinfo);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 178, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'pread' (180). */
asmlinkage static int
stub_syscall_180(unsigned int fd, void* buf, size_t count, loff_t pos) {
	typedef int 
		(*stub_func_180)(unsigned int fd, void* buf, size_t count, loff_t pos);
	typedef int
		(*stub_before_func_180)(unsigned int fd, void* buf, size_t count, loff_t pos, int* syscall_rc); 
	typedef int
		(*stub_after_func_180)(int syscall_rc, unsigned int fd, void* buf, size_t count, loff_t pos);

	stub_func_180 orig_syscall_func;
	stub_before_func_180 before_func;
	stub_after_func_180 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[180];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_180)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_180)hdata->orig_syscall;
	after_func = (stub_after_func_180)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, buf, count, pos , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, buf, count, pos) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, buf, count, pos);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 180, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'pwrite' (181). */
asmlinkage static int
stub_syscall_181(unsigned int fd, void* buf, size_t count, loff_t pos) {
	typedef int 
		(*stub_func_181)(unsigned int fd, void* buf, size_t count, loff_t pos);
	typedef int
		(*stub_before_func_181)(unsigned int fd, void* buf, size_t count, loff_t pos, int* syscall_rc); 
	typedef int
		(*stub_after_func_181)(int syscall_rc, unsigned int fd, void* buf, size_t count, loff_t pos);

	stub_func_181 orig_syscall_func;
	stub_before_func_181 before_func;
	stub_after_func_181 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[181];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_181)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_181)hdata->orig_syscall;
	after_func = (stub_after_func_181)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, buf, count, pos , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, buf, count, pos) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, buf, count, pos);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 181, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'chown16' (182). */
asmlinkage static int
stub_syscall_182(const char* filename, old_uid_t user, old_gid_t group) {
	typedef int 
		(*stub_func_182)(const char* filename, old_uid_t user, old_gid_t group);
	typedef int
		(*stub_before_func_182)(const char* filename, old_uid_t user, old_gid_t group, int* syscall_rc); 
	typedef int
		(*stub_after_func_182)(int syscall_rc, const char* filename, old_uid_t user, old_gid_t group);

	stub_func_182 orig_syscall_func;
	stub_before_func_182 before_func;
	stub_after_func_182 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[182];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_182)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_182)hdata->orig_syscall;
	after_func = (stub_after_func_182)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(filename, user, group , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(filename, user, group) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, filename, user, group);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 182, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getcwd' (183). */
asmlinkage static int
stub_syscall_183(char* buf, unsigned long size) {
	typedef int 
		(*stub_func_183)(char* buf, unsigned long size);
	typedef int
		(*stub_before_func_183)(char* buf, unsigned long size, int* syscall_rc); 
	typedef int
		(*stub_after_func_183)(int syscall_rc, char* buf, unsigned long size);

	stub_func_183 orig_syscall_func;
	stub_before_func_183 before_func;
	stub_after_func_183 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[183];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_183)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_183)hdata->orig_syscall;
	after_func = (stub_after_func_183)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(buf, size , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(buf, size) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, buf, size);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 183, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'capget' (184). */
asmlinkage static int
stub_syscall_184(struct __user_cap_header_struct* header, struct __user_cap_data_struct* dataptr) {
	typedef int 
		(*stub_func_184)(struct __user_cap_header_struct* header, struct __user_cap_data_struct* dataptr);
	typedef int
		(*stub_before_func_184)(struct __user_cap_header_struct* header, struct __user_cap_data_struct* dataptr, int* syscall_rc); 
	typedef int
		(*stub_after_func_184)(int syscall_rc, struct __user_cap_header_struct* header, struct __user_cap_data_struct* dataptr);

	stub_func_184 orig_syscall_func;
	stub_before_func_184 before_func;
	stub_after_func_184 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[184];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_184)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_184)hdata->orig_syscall;
	after_func = (stub_after_func_184)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(header, dataptr , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(header, dataptr) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, header, dataptr);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 184, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'capset' (185). */
asmlinkage static int
stub_syscall_185(struct __user_cap_header_struct* header, const struct __user_cap_data_struct* dataptr) {
	typedef int 
		(*stub_func_185)(struct __user_cap_header_struct* header, const struct __user_cap_data_struct* dataptr);
	typedef int
		(*stub_before_func_185)(struct __user_cap_header_struct* header, const struct __user_cap_data_struct* dataptr, int* syscall_rc); 
	typedef int
		(*stub_after_func_185)(int syscall_rc, struct __user_cap_header_struct* header, const struct __user_cap_data_struct* dataptr);

	stub_func_185 orig_syscall_func;
	stub_before_func_185 before_func;
	stub_after_func_185 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[185];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_185)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_185)hdata->orig_syscall;
	after_func = (stub_after_func_185)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(header, dataptr , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(header, dataptr) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, header, dataptr);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 185, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sendfile' (187). */
asmlinkage static int
stub_syscall_187(int out_fd, int in_fd, off_t* offset, size_t count) {
	typedef int 
		(*stub_func_187)(int out_fd, int in_fd, off_t* offset, size_t count);
	typedef int
		(*stub_before_func_187)(int out_fd, int in_fd, off_t* offset, size_t count, int* syscall_rc); 
	typedef int
		(*stub_after_func_187)(int syscall_rc, int out_fd, int in_fd, off_t* offset, size_t count);

	stub_func_187 orig_syscall_func;
	stub_before_func_187 before_func;
	stub_after_func_187 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[187];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_187)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_187)hdata->orig_syscall;
	after_func = (stub_after_func_187)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(out_fd, in_fd, offset, count , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(out_fd, in_fd, offset, count) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, out_fd, in_fd, offset, count);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 187, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getrlimit' (191). */
asmlinkage static int
stub_syscall_191(int resource, struct rlimit* rlim) {
	typedef int 
		(*stub_func_191)(int resource, struct rlimit* rlim);
	typedef int
		(*stub_before_func_191)(int resource, struct rlimit* rlim, int* syscall_rc); 
	typedef int
		(*stub_after_func_191)(int syscall_rc, int resource, struct rlimit* rlim);

	stub_func_191 orig_syscall_func;
	stub_before_func_191 before_func;
	stub_after_func_191 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[191];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_191)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_191)hdata->orig_syscall;
	after_func = (stub_after_func_191)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(resource, rlim , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(resource, rlim) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, resource, rlim);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 191, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'mmap2' (192). */
asmlinkage static int
stub_syscall_192(unsigned long addr, unsigned long len, unsigned long prot, unsigned long flags, unsigned long fd, unsigned long pgoff) {
	typedef int 
		(*stub_func_192)(unsigned long addr, unsigned long len, unsigned long prot, unsigned long flags, unsigned long fd, unsigned long pgoff);
	typedef int
		(*stub_before_func_192)(unsigned long addr, unsigned long len, unsigned long prot, unsigned long flags, unsigned long fd, unsigned long pgoff, int* syscall_rc); 
	typedef int
		(*stub_after_func_192)(int syscall_rc, unsigned long addr, unsigned long len, unsigned long prot, unsigned long flags, unsigned long fd, unsigned long pgoff);

	stub_func_192 orig_syscall_func;
	stub_before_func_192 before_func;
	stub_after_func_192 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[192];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_192)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_192)hdata->orig_syscall;
	after_func = (stub_after_func_192)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(addr, len, prot, flags, fd, pgoff , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(addr, len, prot, flags, fd, pgoff) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, addr, len, prot, flags, fd, pgoff);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 192, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'truncate64' (193). */
asmlinkage static int
stub_syscall_193(const char* path, loff_t length) {
	typedef int 
		(*stub_func_193)(const char* path, loff_t length);
	typedef int
		(*stub_before_func_193)(const char* path, loff_t length, int* syscall_rc); 
	typedef int
		(*stub_after_func_193)(int syscall_rc, const char* path, loff_t length);

	stub_func_193 orig_syscall_func;
	stub_before_func_193 before_func;
	stub_after_func_193 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[193];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_193)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_193)hdata->orig_syscall;
	after_func = (stub_after_func_193)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(path, length , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(path, length) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, path, length);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 193, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'ftruncate64' (194). */
asmlinkage static int
stub_syscall_194(unsigned int fd, loff_t length) {
	typedef int 
		(*stub_func_194)(unsigned int fd, loff_t length);
	typedef int
		(*stub_before_func_194)(unsigned int fd, loff_t length, int* syscall_rc); 
	typedef int
		(*stub_after_func_194)(int syscall_rc, unsigned int fd, loff_t length);

	stub_func_194 orig_syscall_func;
	stub_before_func_194 before_func;
	stub_after_func_194 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[194];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_194)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_194)hdata->orig_syscall;
	after_func = (stub_after_func_194)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, length , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, length) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, length);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 194, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'stat64' (195). */
asmlinkage static int
stub_syscall_195(char* filename, struct stat64* statbuf, long flags) {
	typedef int 
		(*stub_func_195)(char* filename, struct stat64* statbuf, long flags);
	typedef int
		(*stub_before_func_195)(char* filename, struct stat64* statbuf, long flags, int* syscall_rc); 
	typedef int
		(*stub_after_func_195)(int syscall_rc, char* filename, struct stat64* statbuf, long flags);

	stub_func_195 orig_syscall_func;
	stub_before_func_195 before_func;
	stub_after_func_195 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[195];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_195)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_195)hdata->orig_syscall;
	after_func = (stub_after_func_195)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(filename, statbuf, flags , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(filename, statbuf, flags) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, filename, statbuf, flags);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 195, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'lstat64' (196). */
asmlinkage static int
stub_syscall_196(char* filename, struct stat64* statbuf, long flags) {
	typedef int 
		(*stub_func_196)(char* filename, struct stat64* statbuf, long flags);
	typedef int
		(*stub_before_func_196)(char* filename, struct stat64* statbuf, long flags, int* syscall_rc); 
	typedef int
		(*stub_after_func_196)(int syscall_rc, char* filename, struct stat64* statbuf, long flags);

	stub_func_196 orig_syscall_func;
	stub_before_func_196 before_func;
	stub_after_func_196 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[196];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_196)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_196)hdata->orig_syscall;
	after_func = (stub_after_func_196)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(filename, statbuf, flags , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(filename, statbuf, flags) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, filename, statbuf, flags);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 196, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'fstat64' (197). */
asmlinkage static int
stub_syscall_197(unsigned long fd, struct stat64* statbuf, long flags) {
	typedef int 
		(*stub_func_197)(unsigned long fd, struct stat64* statbuf, long flags);
	typedef int
		(*stub_before_func_197)(unsigned long fd, struct stat64* statbuf, long flags, int* syscall_rc); 
	typedef int
		(*stub_after_func_197)(int syscall_rc, unsigned long fd, struct stat64* statbuf, long flags);

	stub_func_197 orig_syscall_func;
	stub_before_func_197 before_func;
	stub_after_func_197 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[197];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_197)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_197)hdata->orig_syscall;
	after_func = (stub_after_func_197)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, statbuf, flags , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, statbuf, flags) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, statbuf, flags);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 197, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'lchown' (198). */
asmlinkage static int
stub_syscall_198(const char* filename, uid_t user, gid_t group) {
	typedef int 
		(*stub_func_198)(const char* filename, uid_t user, gid_t group);
	typedef int
		(*stub_before_func_198)(const char* filename, uid_t user, gid_t group, int* syscall_rc); 
	typedef int
		(*stub_after_func_198)(int syscall_rc, const char* filename, uid_t user, gid_t group);

	stub_func_198 orig_syscall_func;
	stub_before_func_198 before_func;
	stub_after_func_198 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[198];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_198)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_198)hdata->orig_syscall;
	after_func = (stub_after_func_198)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(filename, user, group , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(filename, user, group) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, filename, user, group);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 198, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getuid' (199). */
asmlinkage static int
stub_syscall_199(void) {
	typedef int 
		(*stub_func_199)(void);
	typedef int
		(*stub_before_func_199)(int* syscall_rc); 
	typedef int
		(*stub_after_func_199)(int syscall_rc);

	stub_func_199 orig_syscall_func;
	stub_before_func_199 before_func;
	stub_after_func_199 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[199];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_199)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_199)hdata->orig_syscall;
	after_func = (stub_after_func_199)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)( &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)() 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval );
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 199, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getgid' (200). */
asmlinkage static int
stub_syscall_200(void) {
	typedef int 
		(*stub_func_200)(void);
	typedef int
		(*stub_before_func_200)(int* syscall_rc); 
	typedef int
		(*stub_after_func_200)(int syscall_rc);

	stub_func_200 orig_syscall_func;
	stub_before_func_200 before_func;
	stub_after_func_200 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[200];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_200)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_200)hdata->orig_syscall;
	after_func = (stub_after_func_200)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)( &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)() 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval );
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 200, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'geteuid' (201). */
asmlinkage static int
stub_syscall_201(void) {
	typedef int 
		(*stub_func_201)(void);
	typedef int
		(*stub_before_func_201)(int* syscall_rc); 
	typedef int
		(*stub_after_func_201)(int syscall_rc);

	stub_func_201 orig_syscall_func;
	stub_before_func_201 before_func;
	stub_after_func_201 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[201];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_201)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_201)hdata->orig_syscall;
	after_func = (stub_after_func_201)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)( &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)() 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval );
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 201, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getegid' (202). */
asmlinkage static int
stub_syscall_202(void) {
	typedef int 
		(*stub_func_202)(void);
	typedef int
		(*stub_before_func_202)(int* syscall_rc); 
	typedef int
		(*stub_after_func_202)(int syscall_rc);

	stub_func_202 orig_syscall_func;
	stub_before_func_202 before_func;
	stub_after_func_202 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[202];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_202)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_202)hdata->orig_syscall;
	after_func = (stub_after_func_202)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)( &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)() 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval );
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 202, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setreuid' (203). */
asmlinkage static int
stub_syscall_203(uid_t ruid, uid_t euid) {
	typedef int 
		(*stub_func_203)(uid_t ruid, uid_t euid);
	typedef int
		(*stub_before_func_203)(uid_t ruid, uid_t euid, int* syscall_rc); 
	typedef int
		(*stub_after_func_203)(int syscall_rc, uid_t ruid, uid_t euid);

	stub_func_203 orig_syscall_func;
	stub_before_func_203 before_func;
	stub_after_func_203 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[203];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_203)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_203)hdata->orig_syscall;
	after_func = (stub_after_func_203)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(ruid, euid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(ruid, euid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, ruid, euid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 203, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setregid' (204). */
asmlinkage static int
stub_syscall_204(gid_t rgid, gid_t egid) {
	typedef int 
		(*stub_func_204)(gid_t rgid, gid_t egid);
	typedef int
		(*stub_before_func_204)(gid_t rgid, gid_t egid, int* syscall_rc); 
	typedef int
		(*stub_after_func_204)(int syscall_rc, gid_t rgid, gid_t egid);

	stub_func_204 orig_syscall_func;
	stub_before_func_204 before_func;
	stub_after_func_204 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[204];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_204)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_204)hdata->orig_syscall;
	after_func = (stub_after_func_204)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(rgid, egid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(rgid, egid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, rgid, egid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 204, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getgroups' (205). */
asmlinkage static int
stub_syscall_205(int gidsetsize, gid_t* grouplist) {
	typedef int 
		(*stub_func_205)(int gidsetsize, gid_t* grouplist);
	typedef int
		(*stub_before_func_205)(int gidsetsize, gid_t* grouplist, int* syscall_rc); 
	typedef int
		(*stub_after_func_205)(int syscall_rc, int gidsetsize, gid_t* grouplist);

	stub_func_205 orig_syscall_func;
	stub_before_func_205 before_func;
	stub_after_func_205 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[205];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_205)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_205)hdata->orig_syscall;
	after_func = (stub_after_func_205)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(gidsetsize, grouplist , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(gidsetsize, grouplist) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, gidsetsize, grouplist);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 205, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setgroups' (206). */
asmlinkage static int
stub_syscall_206(int gidsetsize, gid_t* grouplist) {
	typedef int 
		(*stub_func_206)(int gidsetsize, gid_t* grouplist);
	typedef int
		(*stub_before_func_206)(int gidsetsize, gid_t* grouplist, int* syscall_rc); 
	typedef int
		(*stub_after_func_206)(int syscall_rc, int gidsetsize, gid_t* grouplist);

	stub_func_206 orig_syscall_func;
	stub_before_func_206 before_func;
	stub_after_func_206 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[206];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_206)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_206)hdata->orig_syscall;
	after_func = (stub_after_func_206)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(gidsetsize, grouplist , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(gidsetsize, grouplist) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, gidsetsize, grouplist);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 206, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'fchown' (207). */
asmlinkage static int
stub_syscall_207(unsigned int fd, uid_t user, gid_t group) {
	typedef int 
		(*stub_func_207)(unsigned int fd, uid_t user, gid_t group);
	typedef int
		(*stub_before_func_207)(unsigned int fd, uid_t user, gid_t group, int* syscall_rc); 
	typedef int
		(*stub_after_func_207)(int syscall_rc, unsigned int fd, uid_t user, gid_t group);

	stub_func_207 orig_syscall_func;
	stub_before_func_207 before_func;
	stub_after_func_207 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[207];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_207)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_207)hdata->orig_syscall;
	after_func = (stub_after_func_207)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, user, group , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, user, group) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, user, group);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 207, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setresuid' (208). */
asmlinkage static int
stub_syscall_208(uid_t ruid, uid_t euid, uid_t suid) {
	typedef int 
		(*stub_func_208)(uid_t ruid, uid_t euid, uid_t suid);
	typedef int
		(*stub_before_func_208)(uid_t ruid, uid_t euid, uid_t suid, int* syscall_rc); 
	typedef int
		(*stub_after_func_208)(int syscall_rc, uid_t ruid, uid_t euid, uid_t suid);

	stub_func_208 orig_syscall_func;
	stub_before_func_208 before_func;
	stub_after_func_208 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[208];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_208)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_208)hdata->orig_syscall;
	after_func = (stub_after_func_208)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(ruid, euid, suid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(ruid, euid, suid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, ruid, euid, suid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 208, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getresuid' (209). */
asmlinkage static int
stub_syscall_209(uid_t* ruid, uid_t* euid, uid_t* suid) {
	typedef int 
		(*stub_func_209)(uid_t* ruid, uid_t* euid, uid_t* suid);
	typedef int
		(*stub_before_func_209)(uid_t* ruid, uid_t* euid, uid_t* suid, int* syscall_rc); 
	typedef int
		(*stub_after_func_209)(int syscall_rc, uid_t* ruid, uid_t* euid, uid_t* suid);

	stub_func_209 orig_syscall_func;
	stub_before_func_209 before_func;
	stub_after_func_209 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[209];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_209)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_209)hdata->orig_syscall;
	after_func = (stub_after_func_209)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(ruid, euid, suid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(ruid, euid, suid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, ruid, euid, suid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 209, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setresgid' (210). */
asmlinkage static int
stub_syscall_210(gid_t rgid, gid_t egid, gid_t sgid) {
	typedef int 
		(*stub_func_210)(gid_t rgid, gid_t egid, gid_t sgid);
	typedef int
		(*stub_before_func_210)(gid_t rgid, gid_t egid, gid_t sgid, int* syscall_rc); 
	typedef int
		(*stub_after_func_210)(int syscall_rc, gid_t rgid, gid_t egid, gid_t sgid);

	stub_func_210 orig_syscall_func;
	stub_before_func_210 before_func;
	stub_after_func_210 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[210];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_210)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_210)hdata->orig_syscall;
	after_func = (stub_after_func_210)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(rgid, egid, sgid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(rgid, egid, sgid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, rgid, egid, sgid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 210, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getresgid' (211). */
asmlinkage static int
stub_syscall_211(gid_t* rgid, gid_t* egid, gid_t* sgid) {
	typedef int 
		(*stub_func_211)(gid_t* rgid, gid_t* egid, gid_t* sgid);
	typedef int
		(*stub_before_func_211)(gid_t* rgid, gid_t* egid, gid_t* sgid, int* syscall_rc); 
	typedef int
		(*stub_after_func_211)(int syscall_rc, gid_t* rgid, gid_t* egid, gid_t* sgid);

	stub_func_211 orig_syscall_func;
	stub_before_func_211 before_func;
	stub_after_func_211 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[211];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_211)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_211)hdata->orig_syscall;
	after_func = (stub_after_func_211)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(rgid, egid, sgid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(rgid, egid, sgid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, rgid, egid, sgid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 211, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'chown' (212). */
asmlinkage static int
stub_syscall_212(const char* filename, uid_t user, gid_t group) {
	typedef int 
		(*stub_func_212)(const char* filename, uid_t user, gid_t group);
	typedef int
		(*stub_before_func_212)(const char* filename, uid_t user, gid_t group, int* syscall_rc); 
	typedef int
		(*stub_after_func_212)(int syscall_rc, const char* filename, uid_t user, gid_t group);

	stub_func_212 orig_syscall_func;
	stub_before_func_212 before_func;
	stub_after_func_212 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[212];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_212)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_212)hdata->orig_syscall;
	after_func = (stub_after_func_212)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(filename, user, group , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(filename, user, group) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, filename, user, group);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 212, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setuid' (213). */
asmlinkage static int
stub_syscall_213(uid_t uid) {
	typedef int 
		(*stub_func_213)(uid_t uid);
	typedef int
		(*stub_before_func_213)(uid_t uid, int* syscall_rc); 
	typedef int
		(*stub_after_func_213)(int syscall_rc, uid_t uid);

	stub_func_213 orig_syscall_func;
	stub_before_func_213 before_func;
	stub_after_func_213 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[213];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_213)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_213)hdata->orig_syscall;
	after_func = (stub_after_func_213)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(uid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(uid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, uid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 213, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setgid' (214). */
asmlinkage static int
stub_syscall_214(gid_t gid) {
	typedef int 
		(*stub_func_214)(gid_t gid);
	typedef int
		(*stub_before_func_214)(gid_t gid, int* syscall_rc); 
	typedef int
		(*stub_after_func_214)(int syscall_rc, gid_t gid);

	stub_func_214 orig_syscall_func;
	stub_before_func_214 before_func;
	stub_after_func_214 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[214];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_214)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_214)hdata->orig_syscall;
	after_func = (stub_after_func_214)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(gid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(gid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, gid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 214, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setfsuid' (215). */
asmlinkage static int
stub_syscall_215(uid_t uid) {
	typedef int 
		(*stub_func_215)(uid_t uid);
	typedef int
		(*stub_before_func_215)(uid_t uid, int* syscall_rc); 
	typedef int
		(*stub_after_func_215)(int syscall_rc, uid_t uid);

	stub_func_215 orig_syscall_func;
	stub_before_func_215 before_func;
	stub_after_func_215 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[215];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_215)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_215)hdata->orig_syscall;
	after_func = (stub_after_func_215)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(uid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(uid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, uid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 215, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'setfsgid' (216). */
asmlinkage static int
stub_syscall_216(gid_t gid) {
	typedef int 
		(*stub_func_216)(gid_t gid);
	typedef int
		(*stub_before_func_216)(gid_t gid, int* syscall_rc); 
	typedef int
		(*stub_after_func_216)(int syscall_rc, gid_t gid);

	stub_func_216 orig_syscall_func;
	stub_before_func_216 before_func;
	stub_after_func_216 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[216];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_216)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_216)hdata->orig_syscall;
	after_func = (stub_after_func_216)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(gid , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(gid) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, gid);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 216, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'pivot_root' (217). */
asmlinkage static int
stub_syscall_217(const char* new_root, const char* put_old) {
	typedef int 
		(*stub_func_217)(const char* new_root, const char* put_old);
	typedef int
		(*stub_before_func_217)(const char* new_root, const char* put_old, int* syscall_rc); 
	typedef int
		(*stub_after_func_217)(int syscall_rc, const char* new_root, const char* put_old);

	stub_func_217 orig_syscall_func;
	stub_before_func_217 before_func;
	stub_after_func_217 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[217];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_217)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_217)hdata->orig_syscall;
	after_func = (stub_after_func_217)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(new_root, put_old , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(new_root, put_old) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, new_root, put_old);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 217, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'mincore' (218). */
asmlinkage static int
stub_syscall_218(unsigned long start, size_t len, void* vec) {
	typedef int 
		(*stub_func_218)(unsigned long start, size_t len, void* vec);
	typedef int
		(*stub_before_func_218)(unsigned long start, size_t len, void* vec, int* syscall_rc); 
	typedef int
		(*stub_after_func_218)(int syscall_rc, unsigned long start, size_t len, void* vec);

	stub_func_218 orig_syscall_func;
	stub_before_func_218 before_func;
	stub_after_func_218 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[218];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_218)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_218)hdata->orig_syscall;
	after_func = (stub_after_func_218)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(start, len, vec , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(start, len, vec) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, start, len, vec);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 218, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'madvise' (219). */
asmlinkage static int
stub_syscall_219(unsigned long start, size_t len, int behavior) {
	typedef int 
		(*stub_func_219)(unsigned long start, size_t len, int behavior);
	typedef int
		(*stub_before_func_219)(unsigned long start, size_t len, int behavior, int* syscall_rc); 
	typedef int
		(*stub_after_func_219)(int syscall_rc, unsigned long start, size_t len, int behavior);

	stub_func_219 orig_syscall_func;
	stub_before_func_219 before_func;
	stub_after_func_219 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[219];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_219)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_219)hdata->orig_syscall;
	after_func = (stub_after_func_219)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(start, len, behavior , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(start, len, behavior) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, start, len, behavior);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 219, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'getdents64' (220). */
asmlinkage static int
stub_syscall_220(unsigned int fd, void* dirent, unsigned int count) {
	typedef int 
		(*stub_func_220)(unsigned int fd, void* dirent, unsigned int count);
	typedef int
		(*stub_before_func_220)(unsigned int fd, void* dirent, unsigned int count, int* syscall_rc); 
	typedef int
		(*stub_after_func_220)(int syscall_rc, unsigned int fd, void* dirent, unsigned int count);

	stub_func_220 orig_syscall_func;
	stub_before_func_220 before_func;
	stub_after_func_220 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[220];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_220)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_220)hdata->orig_syscall;
	after_func = (stub_after_func_220)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, dirent, count , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, dirent, count) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, dirent, count);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 220, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'fcntl64' (221). */
asmlinkage static int
stub_syscall_221(unsigned int fd, unsigned int cmd, unsigned long arg) {
	typedef int 
		(*stub_func_221)(unsigned int fd, unsigned int cmd, unsigned long arg);
	typedef int
		(*stub_before_func_221)(unsigned int fd, unsigned int cmd, unsigned long arg, int* syscall_rc); 
	typedef int
		(*stub_after_func_221)(int syscall_rc, unsigned int fd, unsigned int cmd, unsigned long arg);

	stub_func_221 orig_syscall_func;
	stub_before_func_221 before_func;
	stub_after_func_221 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[221];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_221)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_221)hdata->orig_syscall;
	after_func = (stub_after_func_221)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, cmd, arg , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, cmd, arg) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, cmd, arg);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 221, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'gettid' (224). */
asmlinkage static int
stub_syscall_224(void) {
	typedef int 
		(*stub_func_224)(void);
	typedef int
		(*stub_before_func_224)(int* syscall_rc); 
	typedef int
		(*stub_after_func_224)(int syscall_rc);

	stub_func_224 orig_syscall_func;
	stub_before_func_224 before_func;
	stub_after_func_224 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[224];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_224)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_224)hdata->orig_syscall;
	after_func = (stub_after_func_224)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)( &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)() 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval );
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 224, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'readahead' (225). */
asmlinkage static int
stub_syscall_225(int fd, loff_t offset, size_t count) {
	typedef int 
		(*stub_func_225)(int fd, loff_t offset, size_t count);
	typedef int
		(*stub_before_func_225)(int fd, loff_t offset, size_t count, int* syscall_rc); 
	typedef int
		(*stub_after_func_225)(int syscall_rc, int fd, loff_t offset, size_t count);

	stub_func_225 orig_syscall_func;
	stub_before_func_225 before_func;
	stub_after_func_225 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[225];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_225)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_225)hdata->orig_syscall;
	after_func = (stub_after_func_225)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(fd, offset, count , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(fd, offset, count) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, fd, offset, count);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 225, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'tkill' (238). */
asmlinkage static int
stub_syscall_238(int pid, int sig) {
	typedef int 
		(*stub_func_238)(int pid, int sig);
	typedef int
		(*stub_before_func_238)(int pid, int sig, int* syscall_rc); 
	typedef int
		(*stub_after_func_238)(int syscall_rc, int pid, int sig);

	stub_func_238 orig_syscall_func;
	stub_before_func_238 before_func;
	stub_after_func_238 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[238];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_238)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_238)hdata->orig_syscall;
	after_func = (stub_after_func_238)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pid, sig , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pid, sig) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pid, sig);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 238, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sched_setaffinity' (241). */
asmlinkage static int
stub_syscall_241(pid_t pid, unsigned int len, unsigned long* user_mask_ptr) {
	typedef int 
		(*stub_func_241)(pid_t pid, unsigned int len, unsigned long* user_mask_ptr);
	typedef int
		(*stub_before_func_241)(pid_t pid, unsigned int len, unsigned long* user_mask_ptr, int* syscall_rc); 
	typedef int
		(*stub_after_func_241)(int syscall_rc, pid_t pid, unsigned int len, unsigned long* user_mask_ptr);

	stub_func_241 orig_syscall_func;
	stub_before_func_241 before_func;
	stub_after_func_241 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[241];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_241)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_241)hdata->orig_syscall;
	after_func = (stub_after_func_241)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pid, len, user_mask_ptr , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pid, len, user_mask_ptr) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pid, len, user_mask_ptr);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 241, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'sched_getaffinity' (242). */
asmlinkage static int
stub_syscall_242(pid_t pid, unsigned int len, unsigned long* user_mask_ptr) {
	typedef int 
		(*stub_func_242)(pid_t pid, unsigned int len, unsigned long* user_mask_ptr);
	typedef int
		(*stub_before_func_242)(pid_t pid, unsigned int len, unsigned long* user_mask_ptr, int* syscall_rc); 
	typedef int
		(*stub_after_func_242)(int syscall_rc, pid_t pid, unsigned int len, unsigned long* user_mask_ptr);

	stub_func_242 orig_syscall_func;
	stub_before_func_242 before_func;
	stub_after_func_242 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[242];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_242)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_242)hdata->orig_syscall;
	after_func = (stub_after_func_242)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(pid, len, user_mask_ptr , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(pid, len, user_mask_ptr) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, pid, len, user_mask_ptr);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 242, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'socketcall' (102). */
asmlinkage static int
stub_syscall_102(int call, unsigned long* args) {
	typedef int 
		(*stub_func_102)(int call, unsigned long* args);
	typedef int
		(*stub_before_func_102)(int call, unsigned long* args, int* syscall_rc); 
	typedef int
		(*stub_after_func_102)(int syscall_rc, int call, unsigned long* args);

	stub_func_102 orig_syscall_func;
	stub_before_func_102 before_func;
	stub_after_func_102 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[102];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_102)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_102)hdata->orig_syscall;
	after_func = (stub_after_func_102)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(call, args , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(call, args) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, call, args);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 102, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* stub function for syscall 'ipc' (117). */
asmlinkage static int
stub_syscall_117(unsigned int call, int first, int second, int third, int* ptr, long fifth) {
	typedef int 
		(*stub_func_117)(unsigned int call, int first, int second, int third, int* ptr, long fifth);
	typedef int
		(*stub_before_func_117)(unsigned int call, int first, int second, int third, int* ptr, long fifth, int* syscall_rc); 
	typedef int
		(*stub_after_func_117)(int syscall_rc, unsigned int call, int first, int second, int third, int* ptr, long fifth);

	stub_func_117 orig_syscall_func;
	stub_before_func_117 before_func;
	stub_after_func_117 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_pid* pid_trace; 	/* mark that this pid is invoking us */ 
	struct syscall_hijack_data* hdata = &hijack_data[117];

	/* ok, an invocation is in progress */ 
	atomic_inc(&hdata->invocations); 

	pid_trace = setup_pid_trace(); 

	down(&hdata->sem);
	add_pid_trace(pid_trace, hdata); 
	before_func = (stub_before_func_117)hdata->before_hijack_func;	
	orig_syscall_func = (stub_func_117)hdata->orig_syscall;
	after_func = (stub_after_func_117)hdata->after_hijack_func;
	up(&hdata->sem);

	retval = (before_func
	        ? (*before_func)(call, first, second, third, ptr, fifth , &fake_syscall_retval)
		: SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function told us to. */
	if (retval == SCT_USE_ORIG_RETVAL) {
		orig_syscall_retval = (orig_syscall_func 
				       ? (*orig_syscall_func)(call, first, second, third, ptr, fifth) 
				       : -ENOSYS);
		if (after_func)
		        (*after_func)(orig_syscall_retval, call, first, second, third, ptr, fifth);
	}

	down(&hdata->sem);
	remove_pid_trace(pid_trace, hdata); 

	if (atomic_read(&hdata->invocations) == 1 && hdata->defered_release_flag == 1) {
	        /* we couldn't reduce the module's use count when the syscall  */
		/* was originally released (as marked by the 'defered' flag) - */
		/* so we do so now.                                            */
		SCTDBG(DEB_HIJACK, "syscall 117, invocation ref count "
		       "dropped to 0, releasing\n"); 
		hdata->defered_release_flag = 0;
		MOD_DEC_USE_COUNT;
	}
	up(&hdata->sem);

	if (retval == SCT_USE_ORIG_RETVAL)
	        retval = orig_syscall_retval; 
	else 
	        retval = fake_syscall_retval; 
	
	atomic_dec(&hdata->invocations); 

	return retval; 
}

/* pointers to stub functions - to be used */
/* when hijacking system calls.            */
func_ptr stub_functions[] = {
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_3,
	(func_ptr)stub_syscall_4,
	(func_ptr)stub_syscall_5,
	(func_ptr)stub_syscall_6,
	(func_ptr)stub_syscall_7,
	(func_ptr)stub_syscall_8,
	(func_ptr)stub_syscall_9,
	(func_ptr)stub_syscall_10,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_12,
	(func_ptr)stub_syscall_13,
	(func_ptr)stub_syscall_14,
	(func_ptr)stub_syscall_15,
	(func_ptr)stub_syscall_16,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_18,
	(func_ptr)stub_syscall_19,
	(func_ptr)stub_syscall_20,
	(func_ptr)stub_syscall_21,
	(func_ptr)stub_syscall_22,
	(func_ptr)stub_syscall_23,
	(func_ptr)stub_syscall_24,
	(func_ptr)stub_syscall_25,
	(func_ptr)stub_syscall_26,
	(func_ptr)stub_syscall_27,
	(func_ptr)stub_syscall_28,
	(func_ptr)stub_syscall_29,
	(func_ptr)stub_syscall_30,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_33,
	(func_ptr)stub_syscall_34,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_36,
	(func_ptr)stub_syscall_37,
	(func_ptr)stub_syscall_38,
	(func_ptr)stub_syscall_39,
	(func_ptr)stub_syscall_40,
	(func_ptr)stub_syscall_41,
	(func_ptr)stub_syscall_42,
	(func_ptr)stub_syscall_43,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_45,
	(func_ptr)stub_syscall_46,
	(func_ptr)stub_syscall_47,
	(func_ptr)stub_syscall_48,
	(func_ptr)stub_syscall_49,
	(func_ptr)stub_syscall_50,
	(func_ptr)stub_syscall_51,
	(func_ptr)stub_syscall_52,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_54,
	(func_ptr)stub_syscall_55,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_57,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_59,
	(func_ptr)stub_syscall_60,
	(func_ptr)stub_syscall_61,
	(func_ptr)stub_syscall_62,
	(func_ptr)stub_syscall_63,
	(func_ptr)stub_syscall_64,
	(func_ptr)stub_syscall_65,
	(func_ptr)stub_syscall_66,
	(func_ptr)stub_syscall_67,
	(func_ptr)stub_syscall_68,
	(func_ptr)stub_syscall_69,
	(func_ptr)stub_syscall_70,
	(func_ptr)stub_syscall_71,
	(func_ptr)stub_syscall_72,
	(func_ptr)stub_syscall_73,
	(func_ptr)stub_syscall_74,
	(func_ptr)stub_syscall_75,
	(func_ptr)stub_syscall_76,
	(func_ptr)stub_syscall_77,
	(func_ptr)stub_syscall_78,
	(func_ptr)stub_syscall_79,
	(func_ptr)stub_syscall_80,
	(func_ptr)stub_syscall_81,
	(func_ptr)stub_syscall_82,
	(func_ptr)stub_syscall_83,
	(func_ptr)stub_syscall_84,
	(func_ptr)stub_syscall_85,
	(func_ptr)stub_syscall_86,
	(func_ptr)stub_syscall_87,
	(func_ptr)stub_syscall_88,
	(func_ptr)stub_syscall_89,
	(func_ptr)stub_syscall_90,
	(func_ptr)stub_syscall_91,
	(func_ptr)stub_syscall_92,
	(func_ptr)stub_syscall_93,
	(func_ptr)stub_syscall_94,
	(func_ptr)stub_syscall_95,
	(func_ptr)stub_syscall_96,
	(func_ptr)stub_syscall_97,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_99,
	(func_ptr)stub_syscall_100,
	(func_ptr)stub_syscall_101,
	(func_ptr)stub_syscall_102,
	(func_ptr)stub_syscall_103,
	(func_ptr)stub_syscall_104,
	(func_ptr)stub_syscall_105,
	(func_ptr)stub_syscall_106,
	(func_ptr)stub_syscall_107,
	(func_ptr)stub_syscall_108,
	(func_ptr)stub_syscall_109,
	(func_ptr)stub_syscall_110,
	(func_ptr)stub_syscall_111,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_114,
	(func_ptr)stub_syscall_115,
	(func_ptr)stub_syscall_116,
	(func_ptr)stub_syscall_117,
	(func_ptr)stub_syscall_118,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_121,
	(func_ptr)stub_syscall_122,
	(func_ptr)stub_syscall_123,
	(func_ptr)stub_syscall_124,
	(func_ptr)stub_syscall_125,
	(func_ptr)stub_syscall_126,
	(func_ptr)stub_syscall_127,
	(func_ptr)stub_syscall_128,
	(func_ptr)stub_syscall_129,
	(func_ptr)stub_syscall_130,
	(func_ptr)stub_syscall_131,
	(func_ptr)stub_syscall_132,
	(func_ptr)stub_syscall_133,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_135,
	(func_ptr)stub_syscall_136,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_138,
	(func_ptr)stub_syscall_139,
	(func_ptr)stub_syscall_140,
	(func_ptr)stub_syscall_141,
	(func_ptr)stub_syscall_142,
	(func_ptr)stub_syscall_143,
	(func_ptr)stub_syscall_144,
	(func_ptr)stub_syscall_145,
	(func_ptr)stub_syscall_146,
	(func_ptr)stub_syscall_147,
	(func_ptr)stub_syscall_148,
	(func_ptr)stub_syscall_149,
	(func_ptr)stub_syscall_150,
	(func_ptr)stub_syscall_151,
	(func_ptr)stub_syscall_152,
	(func_ptr)stub_syscall_153,
	(func_ptr)stub_syscall_154,
	(func_ptr)stub_syscall_155,
	(func_ptr)stub_syscall_156,
	(func_ptr)stub_syscall_157,
	(func_ptr)stub_syscall_158,
	(func_ptr)stub_syscall_159,
	(func_ptr)stub_syscall_160,
	(func_ptr)stub_syscall_161,
	(func_ptr)stub_syscall_162,
	(func_ptr)stub_syscall_163,
	(func_ptr)stub_syscall_164,
	(func_ptr)stub_syscall_165,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_167,
	(func_ptr)stub_syscall_168,
	(func_ptr)stub_syscall_169,
	(func_ptr)stub_syscall_170,
	(func_ptr)stub_syscall_171,
	(func_ptr)stub_syscall_172,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_174,
	(func_ptr)stub_syscall_175,
	(func_ptr)stub_syscall_176,
	(func_ptr)stub_syscall_177,
	(func_ptr)stub_syscall_178,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_180,
	(func_ptr)stub_syscall_181,
	(func_ptr)stub_syscall_182,
	(func_ptr)stub_syscall_183,
	(func_ptr)stub_syscall_184,
	(func_ptr)stub_syscall_185,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_187,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_191,
	(func_ptr)stub_syscall_192,
	(func_ptr)stub_syscall_193,
	(func_ptr)stub_syscall_194,
	(func_ptr)stub_syscall_195,
	(func_ptr)stub_syscall_196,
	(func_ptr)stub_syscall_197,
	(func_ptr)stub_syscall_198,
	(func_ptr)stub_syscall_199,
	(func_ptr)stub_syscall_200,
	(func_ptr)stub_syscall_201,
	(func_ptr)stub_syscall_202,
	(func_ptr)stub_syscall_203,
	(func_ptr)stub_syscall_204,
	(func_ptr)stub_syscall_205,
	(func_ptr)stub_syscall_206,
	(func_ptr)stub_syscall_207,
	(func_ptr)stub_syscall_208,
	(func_ptr)stub_syscall_209,
	(func_ptr)stub_syscall_210,
	(func_ptr)stub_syscall_211,
	(func_ptr)stub_syscall_212,
	(func_ptr)stub_syscall_213,
	(func_ptr)stub_syscall_214,
	(func_ptr)stub_syscall_215,
	(func_ptr)stub_syscall_216,
	(func_ptr)stub_syscall_217,
	(func_ptr)stub_syscall_218,
	(func_ptr)stub_syscall_219,
	(func_ptr)stub_syscall_220,
	(func_ptr)stub_syscall_221,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_224,
	(func_ptr)stub_syscall_225,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_238,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_241,
	(func_ptr)stub_syscall_242,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
};
